######################################################################
# wiki.cgi - This is PyukiWiki, yet another Wiki clone.
# $Id: wiki.cgi,v 1.172 2006/03/04 13:35:16 papu Exp $
#
# "PyukiWiki" version 0.1.6-rc7 $$
# Copyright (C) 2004-2006 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-2006 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL2 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################
$|=1;	# debug
##############################
# Setting Database Type
#use Yuki::YukiWikiDB;
use Nana::YukiWikiDB;

#$::modifier_dbtype = 'Yuki::YukiWikiDB';
$::modifier_dbtype = 'Nana::YukiWikiDB';

##############################
# Check if the server can use 'AnyDBM_File' or not.
# eval 'use AnyDBM_File';
# my $error_AnyDBM_File = $@;

##############################
# 2005.10.27 pochi: ư󥯵ǽĥ ('?' | 'this' | '')
$::editchar = '?';

##############################
$::subject_delimiter = ' - ';
$::use_autoimg = 1;	# automatically convert image URL into <img> tag.
$::use_exists = 0;	# If you can use 'exists' method for your DB.

##############################
$::version = '0.1.6-rc7';

	# 2005.12.19 pochi: mod_perlǼ¹Բǽ
	# Хؿ
%::functions = (
	"dbmname" => \&dbmname,
	"undbmname" => \&undbmname,
	"htmlspecialchars" => \&htmlspecialchars,
	"javascriptspecialchars" => \&javascriptspecialchars,
	"encode" => \&encode,
	"make_link" => \&make_link,
	"authadminpassword" => \&authadminpassword,
	"code_convert" => \&code_convert,
	"http_header" => \&http_header,
	"load_module" => \&load_module,
	"make_link_url" => \&make_link_url,
	"make_link_mail" => \&make_link_mail,
	"make_link_image" => \&make_link_image,
);

%::values=();

	# 󥿤γĥ

$::counter_ext = '.count';
my $lastmod;			# v0.0.9

%::database;			# database
%::infobase;			# infobase
%::diffbase;			# diffbase
%::interwiki;			# interwiki
$::pageplugin=0;		# is page editing plugin flag

%::_plugined;			# 1:Pyuki/2:Yuki/0:None
%::_exec_plugined;		# 2:Inited/1:Loaded/0:None
%::_exec_plugined_func;	# override functions
%::_exec_plugined_value;# override values
%::_module_loaded;		# perl module
%::_resource_loaded;	# module

@::navi=();				# default navigator link array
@::addnavi=();			# adding navigator link array
%::navi=();				# navigator link
%::dtd;					# dtd define

%::_urlescape;			# for &encode
%::_dbmname_encode;		# for &dbmname
%::_dbmname_decode;		# for &undbmname

%::_date_ampm;			# for &date
%::_date_ampm_locale;
%::_date_weekday;
%::_date_weekdaylength;
%::_date_weekday_locale;
%::_date_weekdaylength_locale;

$::HTTP_HEADER;			# http header
$::IN_HEAD;				# adding <head>~</head> from plugin
$::is_xhtml;

@::notes = ();

	# iniեɤ߹
$::ini_file = 'pyukiwiki.ini.cgi' if($::ini_file eq '');
require $::ini_file;
require $::setup_file if (-r $::setup_file);	# for feature

	# եν
&skin_init;

##############################
	# WikiName
$::wiki_name = '\b([A-Z][a-z]+([A-Z][a-z]+)+)\b';
#my $bracket_name = '\[\[([^\]]+?)\]\]';
	# [[BracketName]]
$::bracket_name ='\[\[((?!\[)[^\]]+?)\]\]';

	# InterWiki
$::interwiki_definition = '\[((?!\[)\S+?)\ (\S+?)\](?!\])';	# ? \[\[(\S+) +(\S+)\]\]
$::interwiki_definition2 = '\[((?!\[)\S+?)\ (\S+?)\](?!\])\ (utf8|euc|sjis|yw|asis|raw|moin)';

	# InterWikiΥ
$::interwiki_name1 = '([^:]+):([^:].*)';
$::interwiki_name2 = '([^:]+):([^:#].*?)(#.*)?';

	# URLɽ
if($::useFileScheme eq 1) {
	$::isurl=q(s?(?:(?:(?:https?|ftp|news)://)|(?:file:[/\x5c][/\x5c]))(?:[-\x5c_.!~*'a-zA-Z0-9;/?:@&=+$,%#]+));
} else {
	$::isurl=qq(s?(?:https?|ftp|news)://[-_.!~*'a-zA-Z0-9;/?:@&=+$,%#]+);
}

	# ᡼륢ɥ쥹ɽ
$::ismail=q((?:[^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff](?:[^(\040)<>@,;:&#".\\\[\]\000-\037\x80-\xff])*(?![^(\040)<>@,;:&#".\\\[\]\000-\037\x80-\xff])|["'][^\\\x80-\xff\n\015"]*(?:\\[^\x80-\xff][^\\\x80-\xff\n\015"]*)*["'])(?:\.(?:[^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff](?:[^(\040)<>@,;:&#".\\\[\]\000-\037\x80-\xff])*(?![^(\040)<>@,;:&#".\\\[\]\000-\037\x80-\xff])|["'][^\\\x80-\xff\n\015"]*(?:\\[^\x80-\xff][^\\\x80-\xff\n\015"]*)*["']))*\.?@(?:[^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff])|\[(?:[^\\\x80-\xff\n\015\[\]]|\\[^\x80-\xff])*\])(?:\.(?:[^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff])|\[(?:[^\\\x80-\xff\n\015\[\]]|\\[^\x80-\xff])*\])));

	# ȥѤ dot ¸ߤʤɥᥤ
$::ismail.=$::IntraMailAddr eq 0 ? '+' : '*';

	# ĥҤɽ
$::image_extention=qq(([Gg][Ii][Ff]|[Pp][Nn][Gg]|[Jj][Pp](?:[Ee])?[Gg]));

##############################
	# ֥åץ饰
$::embed_plugin = '^\#([^\(]+)(\((.*)\))?';
$::embedded_name = '(\#.+?)';
	# 饤󷿥ץ饰
#	$::embed_inline = '(&amp;[^;&]+;|&amp;[^)]+\))';
$::embedded_inline='&amp;(?:([^(;{]+)(?:[()\s?]*?)\s?\{\s?([^&}]*?)\s?\}|([^(;{]+)|([^(;{]+)\s?\(\s?([^)]*?)\s?\)|([^(;{]+)\s?\(\s?([^)]*?)\s?\)\s?\{\s?([^&}]*?)\s?\});';

##############################
	# InfoBasι̾
$::info_ConflictChecker = 'ConflictChecker';
$::info_LastModified = 'LastModified';
$::info_CreateTime='CreateTime';
$::info_LastModifiedTime='LastModifiedTime';
$::info_UpdateTime='UpdateTime';
$::info_IsFrozen = 'IsFrozen';
$::info_AdminPassword = 'AdminPassword';
##############################

	# ڡ̾
%::fixedpage = (
	$::ErrorPage => 1,
	$::RecentChanges => 1,
);

	# ԽԲĥץ饰
%::fixedplugin = (
	'newpage' => 1,
	'search' => 1,
	'list' => 1,
);

	# HTMLפΥơ֥
%::_htmlspecial = (
	'&' => '&amp;',
	'<' => '&lt;',
	'>' => '&gt;',
	'"' => '&quot;',
);

	# HTML󥨥פΥơ֥
%::_unescape = (
	'amp'  => '&',
	'lt'   => '<',
	'gt'   => '>',
	'quot' => '"',
);

	# ʸΥơ֥
%::_facemark = (
	' :)'		=> 'smile',
	' (^^)'		=> 'smile',
	' :D'		=> 'bigsmile',
	' (^-^)'	=> 'bigsmile',
	' :p'		=> 'huh',
	' :d'		=> 'huh',
	' XD'		=> 'oh',
	' X('		=> 'oh',
	' ;)'		=> 'oh',
	' (;'		=> 'wink',
	' (^_-)'	=> 'wink',
	' ;('		=> 'sad',
	' :('		=> 'sad',
	' (--;)'	=> 'sad',
	' (^^;)'	=> 'worried',
	'&heart;'	=> 'heart',
	'&bigsmile;'=> 'bigsmile',
	'&huh;'		=> 'huh',
	'&oh;'		=> 'oh',	
	'&sad;'		=> 'sad',
	'&smile;'	=> 'smile',
	'&wink;'	=> 'wink',
	'&worried;' => 'worried',
);

	# ʸɽ
$::_facemark=q{\ \(--\;\)|\ \(\;|\ \(\^-\^\)|\ \(\^\^\)|\ \(\^\^\;\)|\ \(\^_-\)|\ \:\(|\ \:\)|\ \:D|\ \:d|\ \:p|\ \;\(|\ \;\)|\ X\(|\ XD|\&heart\;};
$::_facemark.=q{|\&bigsmile\;|\&huh\;|\&oh\;|\&sad\;|\&smile\;|\&wink\;|\&worried\;} if($::usePukiWikiStyle eq 1);

	# 饤Υơ֥
%::_inline = (
	q(''')		=> 'em',
	q('')		=> 'strong',
	q(%%%)		=> 'ins',
	q(%%)		=> 'del',
	q(^^)		=> 'sup',
	q(__)		=> 'sub',
);

	# 饤ɽ
$::_inline=q{(__|\^\^|'''?|%%%?)(.+?)(?:__|\^\^|'''?|%%%?)};


	# ޥ
my %command_do = (
	read => \&do_read,
	write => \&do_write,
);

&main;
exit(0);
##############################

=head1 NAME

wiki.cgi - This is PyukiWiki, yet another Wiki clone.

=head1 DESCRIPTION

PyukiWiki is yet another Wiki clone. Based on YukiWiki

PyukiWiki can treat Japanese WikiNames (enclosed with [[ and ]]).
PyukiWiki provides 'InterWiki' feature, RDF Site Summary (RSS),
and some embedded commands (such as [[#comment]] to add comments).

=head1 AUTHOR

=over 4

=item Nekyo

L<http://nekyo.hp.infoseek.co.jp/>

=item PyukiWiki Developers Team

L<http://pyukiwiki.sourceforge.jp/>

=back

=head1 LICENSE

Copyright (C) 2004-2006 by Nekyo.

Copyright (C) 2005-2006 by PyukiWiki Developers Team

License is GNU GENERAL PUBLIC LICENSE 2 and/or Artistic 1 or each later version.

This program is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

=cut

=lang ja

=head1 FUNCTIONS

=head2 main

=over 4

=item 

ʤ

=item 

ʤ

=item С饤

Բ

=item 

PyukiWikiν򤹤롣

=back

=cut

sub main {
	&getbasehref;
	&init_lang;
	&init_dtd;
	&init_global;

	# CGI.pmν
	$qCGI=new CGI;

	# ꥽ɤ߹
	%::resource = &read_resource("$::res_dir/resource.$::lang.txt");

	# ʸν
	&dateinit;

	# ѿ
	$::HTTP_HEADER = '';
	$::IN_HEAD = '';
	if($::P3P ne '') {
		$::HTTP_HEADER.=qq(P3P: CP="$::P3P"\n);
	}

	# &check_modifiers;
	&open_db;				# DB򳫤
	&init_form;				# եν
	&init_InterWikiName;	# interwikiν
	&init_inline_regex;		# 饤ɽν

	# Exץ饰(*.inc.cgi)εư
	&exec_explugin if($::useExPlugin > 0);

	# ޥ(cmd=read, cmd=write)εư
	my $ret=1;
	if ($command_do{$::form{cmd}}) {
		$ret=&{$command_do{$::form{cmd}}};
	}
	# ץ饰(?cmd=)εư
	if($ret eq 1) {
		my $exec = 1;
		if ($::form{cmd}) {
			if (&exist_plugin($::form{cmd}) == 1) {
				my $action = "\&plugin_" . $::form{cmd} . "_action";
				my %ret = eval $action;
				$::debug.=$@;
				if (($ret{msg} ne '') && ($ret{body} ne '')) {
					$::HTTP_HEADER.=$ret{http_header};
					$::IN_HEAD.=$ret{header};
					$exec = 0;
					$::allview = 0 if($ret{notviewmenu} eq 1);
					$::pageplugin=1 if($ret{ispage} eq 1);
					&skinex($ret{msg}, $ret{body});
				}
			}
		}
		if ($exec == 1) {
			$::form{mypage} = $::FrontPage if (!$::form{mypage});
			$::pageplugin=1;
			&do_read;
		}
	}
	# DBĤ
	&close_db;
}

=lang ja

=head2 init_global

=over 4

=item 

ʤ

=item 

ʤ

=item С饤

Բ

=item 

speedy_cgiǼ¹Բǽˤ뤿ν

speedy_cgiǤưϥݡȤƤʤ

=back

=cut

	# 2005.10.27 pochi: speedy_cgiǼ¹Բǽ

sub init_global {
	&close_db;
	%::form = ();
	%::database = ();
	%::infobase = ();
	%::diffbase = ();
	%::interwiki = ();
	%::_resource_loaded = ();
	$lastmod = "";
	%::_plugined = ();
	$::pageplugin=0;
	%::_exec_plugined=();
	%::_exec_plugined_func=();
	%::_exec_plugined_value=();
	%::_module_loaded=();
	# 0255Υơ֥
	foreach my $i (0x00 .. 0xFF) {
		$::_urlescape{chr($i)} = sprintf('%%%02x', $i);
		$::_dbmname_encode{chr($i)} = sprintf('%02X', $i);
		$::_dbmname_decode{sprintf('%02X', $i)} = chr($i);
	}
}

=lang ja

=head2 init_lang

=over 4

=item 

ʤ

=item 

ʤ

=item С饤



=item 

ν򤹤롣

=back

=cut

sub init_lang {
	if ($::lang eq 'ja') {
		$::defaultcode='euc';	# do not change
		if(lc $::charset eq 'utf-8') {
			$::kanjicode='utf8';
		} else {
			$::charset=(
				$::kanjicode eq 'euc' ? 'EUC-JP' :
				$::kanjicode eq 'utf8' ? 'UTF-8' :
				$::kanjicode eq 'sjis' ? 'Shift-JIS' : 
				$::kanjicode eq 'jis' ? 'iso-2022-jp' : '')
		}
	# ν
	} elsif ($::lang eq 'zh') {	# cn is not allow, use zh
		$::charset = 'gb2312' if(lc $::charset ne 'utf-8');
	# Ѹν
	} elsif ($::lang eq 'zh-tw') {
		$::charset = 'big5' if(lc $::charset ne 'utf-8');
	# ڹν
	} elsif ($::lang eq 'ko' || $::lang eq 'kr') {
		$::charset = 'euc-kr' if(lc $::charset ne 'utf-8');
	# ¾
	} else {
		$::charset = 'iso-8859-1' if(lc $::charset ne 'utf-8');
	}
	# $::modifierlink¸ߤʤURL
	$::modifierlink=$::basehref if($::modifierlink eq '');
}

=lang ja

=head2 init_dtd

=over 4

=item 

ʤ

=item 

ʤ

=item С饤



=item 

DTDν򤹤롣

=back

=cut

sub init_dtd {
	# DTDν
	%::dtd = (
		"html4"=>qq(<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">\n<html lang="$::lang">\n<head>\n<meta http-equiv="Content-Language" content="$::lang" />\n<meta http-equiv="Content-Type" content="text/html; charset=$::charset" />),
		"xhtml11"=>qq(<?xml version="1.0" encoding="$::charset"?>\n<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">\n<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="$::lang">\n<head>),
		"xhtml10"=>qq(<?xml version="1.0" encoding="$::charset"?>\n<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n<html xmlns="http://www.w3.org/1999/xhtml" lang="$::lang" xml:lang="$::lang">\n<head>),
		"xhtml10t"=>qq(<?xml version="1.0" encoding="$::charset"?>\n<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n<html xmlns="http://www.w3.org/1999/xhtml" lang="$::lang" xml:lang="$::lang">\n<head>),
		"xhtmlbasic10"=>qq(<?xml version="1.0" encoding="$::charset"?>\n<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML Basic 1.0//EN" "http://www.w3.org/TR/xhtml-basic/xhtml-basic10.dtd">\n<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="$::lang">\n<head>),
	);

	$::dtd=$::dtd{$::htmlmode};
	$::dtd=$::dtd{html4} if($::dtd eq '');
	$::dtd.=<<EOM;

<meta http-equiv="Content-Style-Type" content="text/css" />
<meta http-equiv="Content-Script-Type" content="text/javascript" />
<meta name="generator" content="PyukiWiki $::version" />
EOM

	# XHTMLǤ뤫Υե饰
	$::is_xhtml=$::dtd=~/xml/;
}

=lang ja

=head2 exec_explugin

=over 4

=item 

ʤ

=item 

ʤ

=item С饤

Բ

=item 

ExPluginɤ߹ߡ򤹤롣

=back

=cut

sub exec_explugin {
	# /lib/*.inc.cgi򸡺٤Ƽ¹
	opendir(DIR,"$::explugin_dir");
	while(my $dir=readdir(DIR)) {
		if($dir=~/(.*?)\.inc\.cgi$/) {
			my $explugin=$1;
			&exec_explugin_sub($explugin);
		}
	}
}

=lang ja

=head2 exec_explugin_sub

=over 4

=item 

explugin̾

=item 

ʤ

=item С饤

Բ

=item 

ExPluginɤ߹ߡ򤹤롢exec_expluginؿΥִؿ

=back

=cut

sub exec_explugin_sub {
	my($explugin)=@_;
	if (&exist_explugin($explugin) eq 1) {
		# init᥽åɤμ¹
		my $action = "\&plugin_" . $explugin . "_init";
		my %ret = eval $action;
		$::debug.=$@;
		$::_exec_plugined{$explugin} = 2 if($ret{init}); #execed
		# ʣؿθ
		foreach(split(/,/,$ret{func})) {
			if($_exec_plugined_func{$_} ne '' ) {
				&skinex("\t\t$ErrorPage","$::resource{dupexplugin}<ul><li>$_exec_plugined_func{$_}<li>$explugin</li></ul>");
				exit;
			}
			$_exec_plugined_func{$_}=$explugin;
			$::functions=$ret{$_};
		}
		# ʣ񤭴ؿθ
		foreach(split(/,/,$ret{value})) {
			if($_exec_plugined_value{$_} ne '' ) {
				&skinex("\t\t$ErrorPage","$::resource{dupexplugin}<ul><li>$_exec_plugined_value{$_}<li>$explugin</li></ul>");
				exit;
			}
			$_exec_plugined_value{$_}=$explugin;
			$::values=$ret{$_};
		}
		# إå
		$::HTTP_HEADER.="$ret{http_header}\n";
		$::IN_HEAD.=$ret{header};

		# msg, body ɽƽλʥ顼ѡ
		if (($ret{msg} ne '') && ($ret{body} ne '')) {
			$exec = 0;
			&skinex($ret{msg}, $ret{body});
			exit;
		}
	}
}

=lang ja

=head2 skin_init

=over 4

=item 

ʤ

=item 

$::skin_file, 
$::skin{default_css}, 
$::skin{print_css}, 
$::skin{common_js}, 

=item С饤

Բ

=item 

ե¸ߤåskin.cgiؤνͤ򥻥åȤ롣

=back

=cut

sub skin_init {
	$::skin_file="$::skin_dir/" . &skin_check("$::skin_name.skin%s.cgi",".$::lang","");
	$::skin{default_css}=&skin_check("$::skin_name.default%s.css",".$::lang","");
	$::skin{print_css}=&skin_check("$::skin_name.print%s.css",".$::lang","");
	$::skin{common_js}=&skin_check("common%s.js",".$::kanjicode.$::lang",".$::lang");
}

=lang ja

=head2 skin_check

=over 4

=item 

&skin_check(filename of sprintf format, lists...);

=item 

ʤ

=item С饤



=item 

ɬפʥե뤬¸ߤ뤫å롣

=back

=cut

sub skin_check {
	my($file)=@_;
	foreach(@_) {
		my $f=sprintf($file,$_);
		return $f if(-f "$::skin_dir/$f");
	}
	die sprintf("$file not found","");
	exit;
}

=lang ja

=head2 init_inline_regex

=over 4

=item 

ʤ

=item 

ʤ

=item С饤



=item 

饤ǥ󥯤뤿ɽ롣

=back

=cut

sub init_inline_regex {
	$::inline_regex =qq(($bracket_name)|($embedded_inline));
	$::inline_regex.=qq(|($isurl))						# Direct URL
		if($::autourllink eq 1);
	$::inline_regex.=qq(|(mailto:$ismail)|($ismail))	# Mail
		if($::automaillink eq 1);
	$::inline_regex.=qq(|($wiki_name))					# LocalLinkLikeThis (WikiName)
		if($::nowikiname ne 1);
}

=lang ja

=head2 skinex

=over 4

=item 

&skinex(ڡ̾, (HTML), ڡǤ뤫Υե饰, ڡΥץ饰Ǥ뤫Υե饰);

=item 

stdoutHTML

=item С饤



=item 

ꤷڡޤƤϤ롣

=back

=cut

sub skinex {
	my ($pagename, $body, $is_page, $pageplugin) = @_;
	my $bodyclass = "normal";
	my $editable = 0;
	my $admineditable = 0;
	my ($page,$msg)=split(/\t/,$pagename);
	$pageplugin+=0;
	$::pageplugin+=0;

	if (&is_frozen($page) and ($::form{cmd} =~ /^(read|write)$/ || $pageplugin+$::pageplugin > 0)) {
		$admineditable = 1;
		$bodyclass = "frozen";
	} elsif (&is_editable($page) and ($::form{cmd} =~ /^(read|write)$/ || $pageplugin+$::pageplugin>0)) {
		$admineditable = 1;
		$editable = 1;
		if(!&is_exist_page($pagename) && $is_page) {
			$pagename=$::FrontPage;
			if($::form{mypreview_cancel} ne '') {
				if(&is_exist_page($::form{refer}) && $::form{refer} ne '') {
					$pagename=$::form{refer};
				}
			}
			$body=&text_to_html($::database{$pagename});
			$is_page=1;
			$admineditable=1;
			$editable=&is_frozen($pagename) ? 1 : 0;
		}
	}
	&makenavigator($page,$is_page,$editable,$admineditable);

	$::IN_HEAD=&meta_robots($::form{cmd},$pagename,$body) . $::IN_HEAD;
	$::HTTP_HEADER=&http_header("Content-type: text/html; charset=$::charset", $::HTTP_HEADER);
	require $::skin_file;
	my $body=&skin($pagename, $body, $is_page, $bodyclass, $editable, $admineditable, $::basehref);
	$body=&_db($body);

	if($::lang eq 'ja' && $::defaultcode ne $::kanjicode) {
		$body=&code_convert(\$body,   $::kanjicode);
	}
	&content_output($::HTTP_HEADER, $body);
}

=lang ja

=head2 topicpath

=over 4

=item 

ʤ

=item 

ʸ

=item С饤



=item 

ȥURL,ޤtopicpathɽ롣

ץ饰 topicpath.inc.pl硢ưɤ߹ߤ򤹤롣

=back

=cut

sub topicpath {
	my $buf;
	if($::useTopicPath eq 1 && &exist_plugin(topicpath) ne 0) {
		$buf=&plugin_topicpath_inline(1) if(&is_exist_page($::form{mypage}));
	}
	if($buf eq '') {
		my $cookedurl=$::basehref . '?' . &encode($::form{mypage});
		return qq(<a href="$cookedurl">$cookedurl</a>);
	}
	return $buf;
}

=lang ja

=head2 makenavigator

=over 4

=item 

&makenavigator(ڡ̾, ڡǤ뤫Υե饰, Խǽե饰, Խǽե饰);

=item 

@::navi

=item С饤



=item 

ʥӥʸ󡢥衢ե롣

=back

=cut

sub makenavigator {
	my($pagename,$is_page,$editable,$admineditable)=@_;

	my($page,$message,$errmessage)=split(/\t/,$pagename);	
	my $cookedpage = &encode($page);

	# 󥯤
	foreach("newpage:refer",
			@{[$editable ? "edit:mypage" : ""]},
			@{[$admineditable ? "adminedit:mypage" : ""]},
			@{[$admineditable ? "diff:mypage" : ""]},
			@{[$admineditable && -f "$::plugin_dir/attach.inc.pl" && $::file_uploads > 0 ? "attach:mypage" : ""]},
			@{[$admineditable && -f "$::plugin_dir/rename.inc.pl" ? "rename:refer" : ""]}
		) {
		if($_ ne '') {
			my($t,$r)=split(/:/,$_);
			if($::navi{$t."_url"} eq '') {
				$cookedpage=&encode($::form{refer})
					if($cookedpage eq '' && $::form{refer} ne '');
				$::navi{$t."_title"}=$::resource{$t."thispage"};
				$::navi{$t."_title"}=$::resource{$t."button"}
					if($::navi{$t."_title"} eq '');
				$::navi{$t."_url"}="$::script?cmd=$t&amp;$r=$cookedpage";
				$::navi{$t."_name"}=$::resource{$t."button"}
					if($t!~/rename/);
				$::navi{$t."_type"}="edit";
			}
		}
	}

	foreach("top\t$::FrontPage","reload\t$page","help\t$::resource{help}") {
		my($t,$p)=split(/\t/,$_);
		if(    $t eq "top"
			|| $t eq "help" && &is_exist_page($p)
			|| &is_exist_page($p) && (&is_exist_page($::form{refer}) || $::form{refer} eq '')) {
			if($::navi{$t."_url"} eq '') {
				$::navi{$t."_url"}=&make_cookedurl(&encode(@{[
					&is_exist_page($p) ? $p : 
					&is_exist_page($::form{refer}) ? $::form{refer} : 
					$::FrontPage]}));
				$::navi{$t."_name"}=$::resource{$t};
				$::navi{$t."_type"}="page";
			}
		}
	}

	foreach my $t(@{[$::use_Sitemap eq 1 ? "sitemap" : ""]},
			,"list","search","recent") {
		if($t ne '' && -f "$::plugin_dir/$t.inc.pl") {
			if($::navi{$t."_url"} eq '') {
				$::navi{"$t\_url"}="$::script?cmd=$t&amp;refer=@{[&encode($::form{refer} eq '' ? $::form{mypage} : $::form{refer})]}";
				$::navi{"$t\_name"}=$::resource{$t . "button"};
				$::navi{$t."_type"}="plugin";
			}
		}
	}
	foreach my $t("rss10","rss20","atom","opml") {
		if(-f "$::plugin_dir/$t.inc.pl") {
			if($::navi{$t."_url"} eq '') {
				$::navi{"$t\_url"}="$::script?cmd=$t"
					. ($_exec_plugined{lang} > 1 ? "&amp;lang=$::lang" : "");
				$::navi{"$t\_title"}=$::resource{$t . "button"};
				if(open(R,"$::image_dir/$t.png")) {
					my $data;
					binmode(R);
					read(R, $data, 24);
					close(R);
					$::navi{"$t\_width"}  = unpack("N", substr($data, 16, 20));
					$::navi{"$t\_height"} = unpack("N", substr($data, 20, 24));
				}
				$::navi{$t."_type"}="rsslink";
			}
		}
	}

	# 󥯤¤ӽ
	my @naviindex;
	if($::naviindex eq 0) {
		@naviindex=(
			"reload","","newpage","edit","adminedit","diff","backup","attach","copy","rename","",
			"top","list","sitemap","search","recent","help",
			"rss10","rss20","atom","opml");
	} else {
		@naviindex=(
			"top","","edit","adminedit","diff","backup","attach","copy","rename","reload","",
			"newpage","list","sitemap","search","recent","help",
			"rss10","rss20","atom","opml");
	}

	# ɲå󥯤
	foreach(@naviindex) {
		foreach my $addnavi(@::addnavi) {
			my($index,$before,$next)=split(/:/,$addnavi);
			push(@::navi,$index) if($_ eq $before && $before ne '');
		}
		push(@::navi,$_) if($::navi{"$_\_url"} ne '' || $_ eq '');
		foreach my $addnavi(@::addnavi) {
			my($index,$before,$next)=split(/:/,$addnavi);
			push(@::navi,$index) if($_ eq $next && $next ne '');
		}
	}
}

=lang ja

=head2 meta_robots

=over 4

=item 

&meta_robots(cmdname,ڡ̾,ڡHTML);

=item 

METAHTML

=item С饤



=item 

ܥåȷ󥸥ؤκŬ򤹤롣

=back

=cut

sub meta_robots {
	my($cmd,$pagename,$body)=@_;
	my $robots;
	my $keyword;
	if($cmd=~/edit|admin|diff|attach/
		|| $::form{mypage} eq '' && $cmd!~/list|sitemap|recent/
		|| $::form{mypage}=~/SandBox|$::resource{help}|$::resource{rulepage}|$::MenuBar|$::non_list/
		|| &is_readable($::form{mypage}) eq 0) {
		$robots.=<<EOD;
<meta name="robots" content="NOINDEX,NOFOLLOW,NOARCHIVE" />
<meta name="googlebot" content="NOINDEX,NOFOLLOW,NOARCHIVE" />
EOD
	} else {
		$robots.=<<EOD;
<meta name="robots" content="INDEX,FOLLOW" />
<meta name="googlebot" content="INDEX,FOLLOW,ARCHIVE" />
<meta name="keywords" content="$::meta_keyword" />
EOD
	}
	return $robots;
}

=lang ja

=head2 convtime

=over 4

=item 

ʤ

=item 

ʸ

=item С饤



=item 

PyukiWikiHTMLѴˤäCPU֤֤

=back

=cut

sub convtime {
	if ($::enable_convtime != 0) {
		return sprintf("Powered by Perl $] HTML convert time to %.3f sec.",
			((times)[0] - $::_conv_start));
	}
}

=lang ja

=head2 content_output

=over 4

=item 

&content_output(http_header, body of HTML);

=item 

ɸ

=item С饤



=item 

CGIΤ٤ƤνϤ򤹤롣

=back

=cut

sub content_output {
	my ($http_header,$body)=@_;
	print $http_header;
	$body=~s/\ \/>/>/g if(!$::is_xhtml);
	print $body;
	close(STDOUT);
}

	# not delete for d e b u g
sub _db {
	my($arg)=@_;
	return($arg);
}

=lang ja

=head2 http_header

=over 4

=item 

Ϥhttpإå

=item 

httpإåʸ

=item С饤



=item 

httpإåν򤹤롣

=back

=cut

sub http_header {
	my $http_header;
	my $nph_http_header;
	my $nph_http_header_first;

	foreach(@_) {
		$http_header.="$_\n";
	}
	$http_header=~s/\r//g;
	while($http_header=~/\n\n/) {
		$http_header=~s/\n\n/"\n"/ge;
	}
	$http_header=~s/\n$//g;
	$http_header.="\n";

	# nphץȤξ硢إåƹۤ
	if($ENV{SCRIPT_NAME}=~/nph\-/) {
		$ENV{SERVER_PROTOCOL}="HTTP/1.1" if($ENV{SERVER_PROTOCOL} eq '');
		$nph_http_header_first="$ENV{SERVER_PROTOCOL} 200 OK";
		foreach(split(/\n/,$http_header)) {
			if(/^Status/) {
				s/Status:\s*//g;
				$nph_http_header_first="$ENV{SERVER_PROTOCOL} $_";
				if($_ eq 401) {
					$nph_http_header_first=~s/\n//g;
					$nph_http_header_first.=" Authorization Required\n";
				}
			} else {
				$nph_http_header.="$_\n";
			}
		}
		$http_header=$nph_http_header_first . "\n" . $nph_http_header;
		$http_header.="Cache-Control: max-age=0\n";
		$http_header.=sprintf(
			"Expires: %s GMT\n"
			, &date("D, j M Y G:i:S",0,"gmtime"));
		$http_header=~s/\n\n/\n/g;
	}

	# ԥɤ CRLFˤ
	$http_header=~s/\x0D\x0A|\x0D|\x0A/\x0D\x0A/g;
	return "$http_header\x0D\x0A";
}

=lang ja

=head2 getbasehref

=over 4

=item 

ʤ

=item 

$::basehref, $::basepath, $::script

=item С饤



=item 

ȤʤURL롣ä $::basehrefڤ $::basepathꤵƤ
⤷ʤ

=back

=cut

sub getbasehref {
	# Thanks moriyoshi koizumi.
	return if($::basehref ne '');
	$::basehost = "$ENV{'HTTP_HOST'}";

	# SSLξ
	if (($ENV{'https'} =~ /on/i) || ($ENV{'SERVER_PORT'} eq '443')) {
		$::basehost = 'https://' . $::basehost;
	# httpξ
	} else {
		$::basehost = 'http://' . $::basehost;
		# Special Thanks to gyo
		$::basehost .= ":$ENV{'SERVER_PORT'}"
			if ($ENV{'SERVER_PORT'} ne '80' && $::basehost !~ /:\d/);
	}

	# URL
	my $uri;
	my $req=$ENV{REQUEST_URI};
	$req=~s/\?.*//g;
	if($req ne '') {
		if($req eq $ENV{SCRIPT_NAME}) {
			$uri= $ENV{'SCRIPT_NAME'};
		} else {
			for(my $i=0; $i<length($ENV{SCRIPT_NAME}); $i++) {
				if(substr($ENV{SCRIPT_NAME},$i,1) eq substr($req,$i,1)) {
					$uri.=substr($ENV{SCRIPT_NAME},$i,1);
				} else {
					last;
				}
			}
		}
	} else {
		$uri .= $ENV{'SCRIPT_NAME'};
	}
	$::basehref=$::basehost . $uri;
	$::basepath=$uri;
	$::basepath=~s/\/[^\/]*$//g;
	$::basepath="/" if($::basepath eq '');
	$::script=$uri if($::script eq '');
}

=lang ja

=head2 do_read

=over 4

=item 

ʤ

=item 

ʤ

=item С饤



=item 

ڡɤ߹ߡϤ롣

=back

=cut

sub do_read {
	if(!&is_readable($::form{mypage})) {
		&print_error($::resource{auth_readfobidden});
	}
	# 2005.11.2 pochi: ʬԽǽ
	&skinex($::form{mypage}, &text_to_html($::database{$::form{mypage}}, mypage=>$::form{mypage}), 1, @_);
	return 0;
}

=lang ja

=head2 do_write

=over 4

=item 

&do_write(ʤ ޤ FrozenWrite ʸ);

=item 

ʤ

=item С饤



=item 

ڡ񤭹ߤ롣

=back

=cut

sub do_write {
	#v0.1.6
	my($FrozenWrite)=@_;
	if (not &is_editable($::form{mypage})) {
		&skinex($::form{mypage}, &message($::resource{cantchange}), 0);
		return 0;
	}

	# ڡΥץ饰󤫤ν񤭹ߵ
	if($FrozenWrite eq 'FrozenWrite') {
		if($::writefrozenplugin eq 1) {
			$::form{myfrozen} = &get_info($::form{mypage}, $info_IsFrozen);
		} elsif(&get_info($::form{mypage}, $info_IsFrozen)) {
			$::form{myfrozen}=1;
			if (&frozen_reject()) {
				$::form{cmd}=$::form{refercmd};
				$::form{mypreview} = "";
				&print_error($::resource{auth_writefobidden});
				return 1;
			}
		}
	} else {
		if (&frozen_reject()) {
			$::form{cmd}=$::form{refercmd};
			$::form{mypreview} = "";
			return 1;
		}
	}

	return 0 if (&conflict($::form{mypage}, $::form{mymsg}));

	# 2005.11.2 pochi: ʬԽǽ {
	if ($::form{mypart} =~ /^\d+$/o and $::form{mypart}) {
		$::form{mymsg} =~ s/\x0D\x0A|\x0D|\x0A/\n/og;
		$::form{mymsg} .= "\n" unless ($::form{mymsg} =~ /\n$/o);
		my @parts = &read_by_part($::form{mypage});
		$parts[$::form{mypart} - 1] = $::form{mymsg};
		$::form{mymsg} = join('', @parts);
	}

	# ִ
	$::form{mymsg} =~ s/\&date;/&date($::date_format)/gex;
	$::form{mymsg} =~ s/\&time;/&date($::time_format)/gex;
	$::form{mymsg} =~ s/\&new;/\&new\{@{[&get_now]}\};/gx
		if(-r "$plugin_dir/new.inc.pl");
	if($::usePukiWikiStyle eq 1) {
		$::form{mymsg} =~ s/\&now;/&date($::now_format)/gex;
		$::form{mymsg} =~ s/\&_(date|time|now);/\&$1\(\);/g;
		$::form{mymsg} =~ s/\&t;/\t/g;
		$::form{mymsg} =~ s/\&fpage;/$::form{mypage}/g;
		my $tmp=$::form{mypage};
		$tmp=~s/.*\///g;
		$::form{mymsg} =~ s/&page;/$tmp/g;
	}
	# Making diff
	if (1) {
		&open_diff;
		my @msg1 = split(/\n/, $::database{$::form{mypage}});
		my @msg2 = split(/\n/, $::form{mymsg});
		&load_module("Yuki::DiffText");
		$::diffbase{$::form{mypage}} = Yuki::DiffText::difftext(\@msg1, \@msg2);
		&close_diff;
	}

	# 񤭹ư
	if ($::form{mymsg}) {
		$::form{mymsg}=~s/\x0D\x0A|\x0D|\x0A/\n/g;
		$::database{$::form{mypage}} = $::form{mymsg};
		&send_mail_to_admin($::form{mypage}, "Modify");
		&set_info($::form{mypage}, $::info_ConflictChecker, '' . localtime);
		&set_info($::form{mypage}, $::info_UpdateTime, time);
		if(&get_info($::form{mypage}, $::info_CreateTime)+0 eq 0) {
			&set_info($::form{mypage}, $::info_CreateTime, time);
		}
		if ($::form{mytouch}) {
			&set_info($::form{mypage}, $info_LastModified, '' . localtime);
			&set_info($::form{mypage}, $::info_LastModifiedTime, time);
			&update_recent_changes;
		}
		&set_info($::form{mypage}, $info_IsFrozen, 0 + $::form{myfrozen});
		if($::setting_cookie{savename}+0>0 && $::form{myname} ne '') {
			&plugin_setting_savename($::form{myname});
		}

		# Locationư
		if($::write_location eq 1) {
			print &http_header(
				"Status: 302",
				"Location: $::basehref?@{[&encode($::form{mypage})]}",
				$::HTTP_HEADER
				);
			close(STDOUT);
			exit;
		# ڡɽ
		} else {
			&do_read(1);
		}
	# ư
	} else {
		&send_mail_to_admin($::form{mypage}, "Delete");
		delete $::database{$::form{mypage}};
		delete $infobase{$::form{mypage}};
		&update_recent_changes if ($::form{mytouch});
		&skinex($::form{mypage}, &message($::resource{deleted}), 0);
	}
	return 0;
}

=lang ja

=head2 read_by_part

=over 4

=item 

&read_by_part(ڡ̾);

=item 

ѡȤȤΥڡƤ

=item С饤



=item 

ʬԽΤˡڤФڡƤ֤

=back

=cut

	# 2005.11.2 pochi: ʬԽǽ
sub read_by_part {
	my ($page) = @_;
	return unless &is_exist_page($page);
	my @lines = map { $_."\n" }
			split(/\x0D\x0A|\x0D|\x0A/o, $::database{$page});
	my @parts = ('');
	foreach my $line (@lines) {
		if ($line =~ /^(\*{1,5})(.+)/) {
			push(@parts, $line);
		} else {
			$parts[$#parts] .= $line;
		}
	}
	return @parts;
}

=lang ja

=head2 print_error

=over 4

=item 

&print_error(顼å);

=item 

ʤ

=item С饤



=item 

顼åϤ롣

=back

=cut
sub print_error {
	my ($msg) = @_;
	&skinex("\t\t$ErrorPage", qq(<p><strong class="error">$msg</strong></p>), 0);
	close(STDOUT);
	exit(0);
}

=lang ja

=head2 print_content

=over 4

=item 

&print_content(wikiʸ, ڡ̾);

=item 

HTML

=item С饤



=item 

wikiʸϤHTMLѴ롣(ѡ

=back

=cut

sub print_content {
	my ($rawcontent,$nowpagename) = @_;
	$::form{basepage}=$nowpagename eq '' ? $::form{mypage} : $nowpagename;
	return &text_to_html($rawcontent);
}

=lang ja

=head2 text_to_html

=over 4

=item 

&text_to_html(wikiʸ,%ץ);

=item 

HTML

=item С饤



=item 

wikiʸϤHTMLѴ롣

=back

=cut

sub text_to_html {
	# 2005.10.31 pochi: ץǽ {
	my ($txt, %option) = @_;
	my (@txt) = split(/\r?\n/, $txt);
	my $verbatim;
	my $tocnum = 0;
	my (@saved, @result);
	my $prevline;
	my @col_style;
	unshift(@saved, "</p>");
	push(@result, "<p>");
	# 2006.1.30 pochi: ԥ⡼ɤ
	my $lfmode = 0;

	# 2005.10.31 pochi: ʬԽǽ
	my $editpart = "";
	if($::partedit > 0) {
		if ($option{mypage}) {
			my ($title, $edit, $button);
			if (&is_frozen($option{mypage})) {
				$title = "admineditthispart";
				$edit = "adminedit";
				$button = "admineditbutton";
			} else {
				$title = "editthispart";
				$edit = "edit";
				$button = "editbutton";
			}
			my $enc_mypage = &encode($option{mypage});
			$enc_mypage =~ s/%/%%/og;
			if($::partedit eq 2 || $edit eq 'edit') {
				$editpart = qq(<div class="partinfo"><a class="partedit" title="$::resource{$title}" href="$::script?cmd=$edit&amp;mypage=$enc_mypage&amp;mypart=%d">@{[$::toolbar eq 2 ? qq(<img src="$::image_url/partedit.png" height="16" width="16" alt="$::resource{$button}" />) : $::resource{$button}]}</a></div>);
			}
		}
	}
	my $backline;	# ʣб
	my $backcmd;
	my $nest;
	foreach (@txt) {
		@col_style=() if(!/^(\,|\|)/);
		chomp;

		# backline
		if($backline ne '') {
			$_=$backline . $_;
			$backline="";
		}
		# verbatim.
		if ($verbatim->{func}) {
			if (/^\Q$verbatim->{done}\E$/) {
				undef $verbatim;
				push(@result, splice(@saved));
			} else {
				push(@result, $verbatim->{func}->($_));
			}
			next;
		}
		# non-verbatim follows.
		push(@result, shift(@saved)) if (@saved and $saved[0] eq '</pre>' and /^[^ \t]/);
		my $escapedscheme=$_;
		# v0.1.6 url or mail scheme escape to [BS] or [TAB]
		if($escapedscheme=~/($isurl|mailto:$ismail)/) {
			my $url1=$1;
			my $url2=$url1;
			$url2=~s!:!\x08!g;
			$url2=~s!/!\x07!g;
			$escapedscheme=~s!\Q$url1!$url2!g;
		}

		# ʣб
		if($::usePukiWikiStyle eq 1) {
			if(/^:(.*)[|:]+$/) {
				$backline=$_;
				next;
			} elsif(/^(:|>{1,3}|-{1,3}|\+{1,3})(.+)~$/) {
				$backline="$1$2\x06";
				next;
			}
		}

		# * ** *** **** *****
		if (/^(\*{1,5})(.+)/) {
			my $hn = "h" . (length($1) + 1);	# $hn = 'h2'-'h6'
			my $hedding = ($tocnum != 0)
				? qq(<div class="jumpmenu"><a href="@{[$::form{cmd} ne 'read' ? "?$ENV{QUERY_STRING}" : &make_cookedurl($::pushedpage eq '' ? $::form{mypage} : $::pushedpage)]}#navigator">&uarr;</a></div>\n)
				: '';
			push(@result, splice(@saved),
				$hedding . qq(<$hn id="@{[&pageanchorname($::form{mypage})]}$tocnum">) . &inline($2) . qq(</$hn>)
			);
			# 2005.10.31 pochi: ʬԽǽ {
			push(@result, sprintf($editpart, $tocnum + 2)) if($editpart);
			$tocnum++;
		# verbatim
		} elsif (/^(-{2,3})\($/) {
			if ($& eq '--(') {
				$verbatim = { func => \&inline, done => '--)', class => 'verbatim-soft' };
			} else {
				$verbatim = { func => \&escape, done => '---)', class => 'verbatim-hard' };
			}
			&back_push('pre', 1, \@saved, \@result, " class='$verbatim->{class}'");
		} elsif (/^{{{/) {	# OpenWiki like. Thanks wadldw.
			$verbatim = { func => \&inline, done => '}}}', class => 'verbatim-soft' };
			&back_push('pre', 1, \@saved, \@result, " class='$verbatim->{class}'");
		# hr
		} elsif (/^----/) {
			push(@result, splice(@saved), '<hr />');
		# - -- ---
		} elsif (/^(-{1,3})(.+)/) {
			my $class = "";
			if($::usePukiWikiStyle eq 1) {
				push(@result, shift(@saved))
					if($nest ne $1);
				$nest=$1;
				my $margin;
				$class=qq( class="plist) . length($1) . qq(");
				&back_push('ul', 1, \@saved, \@result,$class);
			} else {
				if ($::form{mypage} ne $::MenuBar) {
					$class=qq( class="list) . length($1) . qq(");
				}
				&back_push('ul',length($1), \@saved, \@result, $class);
			}
			push(@result, '<li>' . &inline($2) . '</li>');
		# + ++ +++
		} elsif (/^(\+{1,3})(.+)/) {
			my $class = "";
			if($::usePukiWikiStyle eq 1) {
				push(@result, shift(@saved))
					if($nest ne $1);
				$nest=$1;
				my $margin;
				$margin=$::form{mypage} eq $::MenuBar
					? 2+4*length($1) : 16*length($1);
				$class=qq( class="plist) . length($1) . qq(")
				&back_push('ol', 1, \@saved, \@result,$class);
			} else {
				if ($::form{mypage} ne $::MenuBar) {
					$class=qq( class="list) . length($1) . qq(");
				}
				&back_push('ol',length($1), \@saved, \@result, $class);
			}
			push(@result, '<li>' . &inline($2) . '</li>');
		# : ... : ... / : ... | ...
		} elsif (/^:/) {
			$escapedscheme=~/^(:{1,3})(.+)/;
			my $chunk=$2;
			my $class = "";
			if ($::form{mypage} ne $::MenuBar) {
				$class=qq( class="list) . length($1) . qq(");
			}
			# thanks making testdata tenk*
			$chunk=~s/\[\[([^:\]]+?):((?!\[)[^\]]+?)\]\]/[[$1\x08$2]]/g
				while($chunk=~/\[\[([^:\]]+?):((?!\[)[^\]]+?)\]\]/);
			if ($chunk=~/^([^\|]+):(.+)\|(.*)/) {
				&back_push('dl', 1, \@saved, \@result, $class);
				push(@result, '<dt>' . &inline($1) . '</dt>', '<dd>' . &inline("$2|$3") . '</dd>');
			} elsif ($chunk=~/^([^\|]+)\|(.*)/) {
				&back_push('dl', 1, \@saved, \@result, $class);
				push(@result, '<dt>' . &inline($1) . '</dt>', '<dd>' . &inline($2) . '</dd>');
			} elsif ($chunk=~/^([^:]+):(.+)/) {
				&back_push('dl', 1, \@saved, \@result, $class);
				push(@result, '<dt>' . &inline($1) . '</dt>', '<dd>' . &inline($2) . '</dd>');
			} else {
				&back_push('dl', 1, \@saved, \@result, $class);
				push(@result, '<dt>' . &inline($chunk) . '</dt>', '<dd></dd>');
			}
		# > >> >>> >>>> >>>>>
		} elsif (/^(>{1,5})(.+)/) {
			&back_push('blockquote', length($1), \@saved, \@result);
			push(@result, qq(<p class="quotation">))
				if($::usePukiWikiStyle eq 1);
			push(@result, &inline($2));
			push(@result, qq(</p>\n))
				if($::usePukiWikiStyle eq 1);
		# null
		} elsif (/^$/) {
			push(@result, splice(@saved));
			unshift(@saved, "</p>");
			push(@result, "<p>");
		# pre
		# 2005.11.16 pochi: ѤΰιƬ
#		} elsif (/^(\s+.*)$/) {
		} elsif (/^\s(.*)$/o) {
			&back_push('pre', 1, \@saved, \@result);
			push(@result, &htmlspecialchars($1)); # Not &inline, but &escape
		# table
		} elsif (/^([\,|\|])(.*?)[\x0D\x0A]*$/) {
			&back_push('table', 1, \@saved, \@result,
				' class="style_table" cellspacing="1" border="0"',
				'<div class="ie5">', '</div>');
			#######
			# This part is taken from Mr. Ohzaki's Perl Memo and Makio Tsukamoto's WalWiki.
			my $delm = "\\$1";
			my $tmp = ($1 eq ',') ? "$2$1" : "$2";
			my @value = map {/^"(.*)"$/ ? scalar($_ = $2, s/""/"/g, $_) : $_}
				($tmp =~ /("[^"]*(?:""[^"]*)*"|[^$delm]*)$delm/g);
			my @align = map {(s/^\s+//) ? ((s/\s+$//) ? ' align="center"' : ' align="right"') : ''} @value;
			my @colspan = map {$_ eq '==' ? 0 : 1} @value;
			my $pukicolspan=1;
			my $thflag='td';

			for (my $i = 0; $i < @value; $i++) {
				if ($colspan[$i]) {
					if($::usePukiWikiStyle eq 1) {
						# <th>
						if($value[$i]=~/^\~/) {
							$value[$i]=~s/^\~//g;
							$thflag='th';
						} elsif($value[$i] eq '~') {
							$value[$i]="";
							# reserved rowspan
						}
						# right colspan
						if($value[$i] eq '>') {
							$value[$i]='';
							$pukicolspan++;
							next;
						}
					}
					while ($i + $colspan[$i] < @value and  $value[$i + $colspan[$i]] eq '==') {
						$colspan[$i]++;
					}
					$colspan[$i] = ($colspan[$i] > 1) ? sprintf(' colspan="%d"', $colspan[$i]) : '';
					if($pukicolspan > 1 && $::usePukiWikiStyle eq 1) {
						$colspan[$i] = sprintf(' colspan="%d"', $pukicolspan);
						$pukicolspan=1;
					}
					if($::usePukiWikiStyle eq 1) {
						$value[$i]=~ s!(LEFT|CENTER|RIGHT)\:!\ftext-align:$1;\t!g;
						$value[$i]=~ s!BGCOLOR\((.*?)\)\:(.*)!\fbackground-color:$1;\t$2!g;
						$value[$i]=~ s!COLOR\((.*?)\)\:(.*)!\fcolor:$1;\t$2!g;
						$value[$i]=~ s!SIZE\((.*?)\)\:(.*)!\ffont-size:$1px;\t$2!g;
						if($value[$i]=~/\f/) {
							$value_style[$i]=$value[$i];
							$value_style[$i]=~s!\t\f!!g;
							$value_style[$i]=~s!\t(.*)$!!g;
							$value_style[$i]=~s!\f!!g;
							$value[$i]=~s/\f(.*?)\t//g;
						}
						if($tmp=~/(\,|\|)c$/) {
							$col_style[$i]=$value_style[$i];
						} else {
							$value[$i] = sprintf('<%s%s%s class="style_%s" style="%s%s">%s</%s>', $thflag,$align[$i], $colspan[$i], $thflag,$col_style[$i],$value_style[$i],&inline($value[$i]),$thflag);
							$value_style[$i]="";
						}
					} else {
						$value[$i] = sprintf('<td%s%s class="style_td">%s</td>', $align[$i], $colspan[$i], &inline($value[$i]));
					}
				} else {
					$value[$i] = '';
				}
			}
			if($::usePukiWikiStyle eq 0) {
				push(@result, join('', '<tr>', @value, '</tr>'));
			} elsif($tmp=~/(\,|\|)h$/) {
				push(@result, join('', '<thead><tr>',@value,'</tr></thead>'));
			} elsif($tmp=~/(\,|\|)f$/) {
				push(@result, join('', '<tfoot><tr>',@value,'</tr></tfoot>'));
			} elsif($tmp!~/(\,|\|)c$/) {
				push(@result, join('', '<tr>', @value, '</tr>'));
			}
			# XXXXX
			#######
		# ====
		} elsif (/^====/) {
			if ($::form{show} ne 'all') {
				push(@result, splice(@saved), "<a href=\"$::script?cmd=read&amp;mypage="
					. &encode($::form{mypage}) . "&show=all\">$::resource{continue_msg}</a>");
				last;
			}
		# 2006.1.30 pochi: ԥ⡼ɤ {
		} elsif (/^\&\*lfmode\((\d+)\);$/o) {
			$lfmode = $1;
		# ֥åץ饰
		} elsif (/^$embedded_name$/o) {
			s/^$embedded_name$/&embedded_to_html($1)/gexo;	# #command
			&back_push('div', 1, \@saved, \@result);
			push(@result,$_);
		} else {
			# 2006.1.30 pochi: ԥ⡼ɤ
#			&back_push('p', 1, \@saved, \@result);
			push(@result, &inline($_, ("lfmode" => $lfmode)));
		}
	}
	push(@result, splice(@saved));
	# 2005.10.31 pochi: ʬԽǽ
	if ($editpart && $::partfirstblock eq 1) {
		unshift(@result, sprintf($editpart, 1));
	}
	return join("\n",@result);
}

=lang ja

=head2 pageanchorname

=over 4

=item 

ڡ̾

=item 

󥫡̾(ʸ

=item С饤



=item 

ڡ̾Ф륢󥫡̾Ϥ롣

=back

=cut

sub pageanchorname {
	my ($page)=@_;
	return 'm' if($page eq $::MenuBar && $::MenuBar ne '');
	return 'r' if($page eq $::RightBar && $::RightBar ne '');
	return 'h' if($page eq $::Header && $::Header ne '');
	return 'f' if($page eq $::Footer && $::Footer ne '');
	return 'i';
}

=lang ja

=head2 back_push

=over 4

=item 

&backpush($tag, $level, $savedref, $resultref, $attr, $with_open, $with_close);

=item 

ʤ

=item С饤



=item 

HTMLpush롣

=back

=cut

sub back_push {
	my ($tag, $level, $savedref, $resultref, $attr, $before_open, $after_close,$after_open,$before_close) = @_;
	while (@$savedref > $level) {
		push(@$resultref, shift(@$savedref));
	}
	if ($savedref->[0] ne "$before_close</$tag>$after_close") {
		push(@$resultref, splice(@$savedref));
	}
	while (@$savedref < $level) {
		unshift(@$savedref, "$before_close</$tag>$after_close");
		push(@$resultref, "$before_open<$tag$attr>$after_open");
	}
}

=lang ja

=head2 inline

=over 4

=item 

&inline(饤wikiʸ,%option);

=item 

HTML

=item С饤



=item 

饤wikiʸϤHTMLѴ롣

=back

=cut

$::_inline_attr="";

sub inline {
	#2006.1.30 pochi: ץǽ
	my ($line, %option) = @_;
	$line =~ tr|\x08|:|;							# escaped scheme v0.1.6
	$line =~ tr|\x07|/|;							# escaped scheme v0.1.6
#	$line =~ s|^//.*$||g;							# Comment
	$line =~ s|^//.*||g;							# Comment
	$line =~ s|\s//\s\#.*$||g;						# Comment # debug
	$line = &htmlspecialchars($line);

	$line=~s!$::_inline!<$::_inline{$1}>$2</$::_inline{$1}>!go;

#	$line =~ s|'''(.+?)'''|<em>$1</em>|g;			# Italic
#	$line =~ s|''(.+?)''|<strong>$1</strong>|g;		# Bold
#	$line =~ s|%%%(.+?)%%%|<ins>$1</ins>|g;			# Insert Line
#	$line =~ s|%%(.+?)%%|<del>$1</del>|g;			# Delete Line
#	$line =~ s|\^\^(.+?)\^\^|<sup>$1</sup>|g;		# sup
#	$line =~ s|__(.+?)__|<sub>$1</sub>|g;			# sub

#	$line =~ s|'''([^']+?)'''|<em>$1</em>|g;		# Italic
#	$line =~ s|''([^']+?)''|<strong>$1</strong>|g;	# Bold
#	$line =~ s|%%%([^%]*)%%%|<ins>$1</ins>|g;		# Insert Line
#	$line =~ s|%%([^%]*)%%|<del>$1</del>|g;			# Delete Line
#	$line =~ s|\^\^([^\^]*)\^\^|<sup>$1</sup>|g;	# sup
#	$line =~ s|__([^_]*)__|<sub>$1</sub>|g;			# sub

	$line =~ s|(\d\d\d\d-\d\d-\d\d \(\w\w\w\) \d\d:\d\d:\d\d)|<span class="date">$1</span>|g;	# Date

	if($::usePukiWikiStyle eq 1) {
		if($line=~/~$/) {
			if($line=~/^(LEFT|CENTER|RIGHT|RED|BLUE|GREEN):/) {
				$::_inline_attr=$1;
				$line=~s/^$::_inline_attr://g;
			}
		} else {
			$::_inline_attr="";
		}
		if($::_inline_attr ne '') {
			$line="$::_inline_attr:$line";
		}
	}
	#2006.1.30 pochi: ԥ⡼ɤ {
	if ($option{"lfmode"}) {
		if ($line !~ /^$embedded_name$/o) {
			if (!($line =~ s/\\$//o)) {
				$line .= "<br />";
			}
		}
	} else {
		$line =~ s|~$|<br />|o;
		$line =~ s|\x06|<br />|g;					# escaped scheme v0.1.6
	}

	$line =~ s!^(LEFT|CENTER|RIGHT):(.*)$!<div style="text-align:$1">$2</div>!g;
	$line =~ s!^(RED|BLUE|GREEN):(.*)$!<font color="$1">$2</font>!g;# Tnx hash.

	if($::usePukiWikiStyle eq 1) {
		$line =~ s!BGCOLOR\((.*?)\)\s*\{\s*(.*)\s*\}!<span style="background-color:$1">$2</span>!g;
		$line =~ s!COLOR\((.*?)\)\s*\{\s*(.*)\}!<span style="color:$1">$2</span>!g;
		$line =~ s!SIZE\((.*?)\)\s*\{\s*(.*)\s*\}!<span style="font-size:$1px">$2</span>!g;
	}

	$line =~ s!&version;!$::version!g;
	$line =~ s!($::inline_regex)!&make_link($1)!geo;
	$line =~ s!($embedded_inline)!&embedded_inline($1)!geo
		if($::usePukiWikiStyle eq 1);	# 2ͥȤޤǵ

	$line =~ s|\(\((.*)\)\)|&note($1)|gex;
	$line =~ s|\(\((.*)\)\)||gex;

	$line =~ s|\[\#(.*)\]|<a class="anchor_super" id="$1" href="#$1" title="$1">$::_symbol_anchor</a>|g;
	# ʸ
	if ($::usefacemark == 1) {
		$line=~s!($::_facemark)!<img src="$::image_url/face/$::_facemark{$1}.png" alt="$1" />!go;
	}
	return $line;
}

=lang ja

=head2 note

=over 4

=item 

&note(Υ饤wikiʸ);

=item 

ؤΥHTML

=item С饤



=item 

¸ؤΥ󥫡󥯤롣

=back

=cut

sub note {
	my ($msg) = @_;
	push(@::notes, $msg);
	# thanks to Ayase
	return "<a @{[$::is_xhtml ? 'id' : 'name']}=\"notetext_" . @::notes . "\" "
		. "href=\"" . &make_cookedurl(&encode($::form{mypage})) . "#notefoot_" . @::notes . "\" class=\"note_super\">*"
		. @::notes . "</a>";
}

=lang ja

=head2 make_link

=over 4

=item 

&make_link(Ф줿);

=item 

󥯤Ѵ줿HTML

=item С饤



=item 

󥯤롣

=back

=cut

sub make_link {
	my $chunk = shift;
	my $orgchunk=$chunk;

#	} elsif ($chunk =~ /^$interwiki_definition2$/) {
#		return qq(<span class="InterWiki">) . &make_link_url("interwiki",$1,$2) . " $3</span>";
#	} elsif ($chunk =~ /^$interwiki_definition$/) {
#		return qq(<span class="InterWiki">) . &make_link_url("interwiki",$1,$2) . "</span>";
#	} elsif ($chunk =~ /^$embedded_inline/o) {

	# 饤ץ饰
	if ($chunk =~ /^$embedded_inline/o) {
		if($::usePukiWikiStyle eq 1) {
			return &embedded_inline($chunk,2);
		} else {
			return &embedded_inline($chunk);
		}
	}
#	$chunk = &unescape(&unarmor_name($chunk));
#	my $cookedchunk = &encode($chunk);
#	my $escapedchunk = &htmlspecialchars($chunk);
	my $escapedchunk=&unarmor_name($chunk);
	$chunk=&unescape($escapedchunk);
	# url
#	if ($chunk =~ /^(https?|ftp):/) {
	if ($chunk =~ /^$::isurl$/o) {
		my $tmp=&make_link_urlhref($chunk);
		if ($use_autoimg and $chunk =~ /\.$::image_extention$/o) {
			return &make_link_url("url",$tmp,$tmp,$tmp);
		} else {
			return &make_link_url("url",$tmp,$tmp);
#			return &make_link_url("url",$chunk,$escapedchunk);
		}
	}
	# [[intername:wiki#anchor]]
	if ($chunk!~/>/ && $chunk =~ /^$interwiki_name2$/o && $chunk!~/$isurl|$ismail/o) {
		my $chunk1=&make_link_interwiki($1,$2,$3,$escapedchunk);
		return $chunk1 if($chunk1 ne '');
	# [[intername:wiki]]
	} elsif ($chunk!~/>/ && $chunk =~ /^$interwiki_name1$/o && $chunk!~/$isurl|$ismail/o) {
		$escapedchunk=&make_link_interwiki($1,$2,$escapedchunk);
		return $chunk1 if($chunk1 ne '');
	}
 	if($chunk!~/>/ && $chunk=~/$ismail/o) {
		# mailto:mail@address
	 	if($chunk=~/([Mm][Aa][Ii][Ll][Tt][Oo]):$::ismail/o) {
			$chunk=~s/[Mm][Aa][Ii][Ll][Tt][Oo]://g;
			return &make_link_mail($chunk,$escapedchunk);
		}
		# [[mail@address]]
	 	if($chunk=~/^$::ismail$/o) {
			return &make_link_mail($chunk,$escapedchunk);
		}
	}
	# [[name>alias]]
	if($chunk=~/^([^>]+)>(.+)$/) {
		$escapedchunk=$1;
		my $chunk2=$2;
		#[[http://some/image.(gif|png|jpe?g)>???]]
		if ($use_autoimg && $escapedchunk=~/$isurl/o && $escapedchunk =~ /\.$::image_extention$/o) {
			$escapedchunk=&make_link_image($escapedchunk);
		} else {
			$escapedchunk=&htmlspecialchars($escapedchunk);
		}
		# [[name>mailto:mail@address]] or [[name>mail@address]]
		if($chunk2=~/$ismail/o) {
		 	if($chunk2=~/([Mm][Aa][Ii][Ll][Tt][Oo]):$ismail/o) {
				$chunk2=~s/[Mm][Aa][Ii][Ll][Tt][Oo]://g;
			}
			return &make_link_mail($chunk2,$escapedchunk);
		# [[name>http://url/]]
		} elsif($chunk2=~/$isurl/o) {
			return &make_link_url("link",$chunk2,$escapedchunk);
		# [[name>intername:wiki#anchor]]
		} elsif($chunk2=~/^$interwiki_name2$/o) {
			my $chunk1=&make_link_interwiki($1,$2,$3,$escapedchunk);
			return $chunk1 if($escapedchunk ne '');
		# [[name>intername:wiki]]
		} elsif($chunk2=~/^$interwiki_name1$/o) {
			my $chunk1=&make_link_interwiki($1,$2,$escapedchunk);
			return $chunk1 if($escapedchunk ne '');
		} elsif($chunk=~/^$isurl/o) {
			if ($use_autoimg and $escapedchunk =~ /\.$::image_extention$/o) {
				return &make_link_url("image",$chunk,$chunk,$escapedchunk);
			} else {
				return &make_link_url("url",$chunk,$chunk);
			}
		}
	}
	# [[name:alias]]
	if($chunk=~/^(.+?):(.+)$/ && $chunk!~/^file/) {
		$escapedchunk=$1;
		my $chunk2=$2;
		#[[http://some/image.(gif|png|jpe?g)>???]]
		if ($use_autoimg && $escapedchunk=~/$isurl/o && $escapedchunk =~ /\.$::image_extention$/o) {
			$escapedchunk=&make_link_image($escapedchunk);
		} else {
			$escapedchunk=&htmlspecialchars($escapedchunk);
		}
		# [[name>mailto:mail@address]] or [[name>mail@address]]
		if($chunk2=~/$ismail/o) {
		 	if($chunk2=~/([Mm][Aa][Ii][Ll][Tt][Oo]):$ismail/o) {
				$chunk2=~s/[Mm][Aa][Ii][Ll][Tt][Oo]://g;
			}
			return &make_link_mail($chunk2,$escapedchunk);
		# [[name>http://url/]]
		} elsif($chunk2=~/$isurl/o) {
			return &make_link_url("link",$chunk2,$escapedchunk);
		# [[name>intername:wiki#anchor]]
		} elsif($chunk2=~/^$interwiki_name2$/o) {
			my $chunk1=&make_link_interwiki($1,$2,$3,$escapedchunk);
			return $chunk1 if($escapedchunk ne '');
		# [[name>intername:wiki]]
		} elsif($chunk2=~/^$interwiki_name1$/o) {
			my $chunk1=&make_link_interwiki($1,$2,$escapedchunk);
			return $chunk1 if($escapedchunk ne '');
		} elsif($chunk=~/^$isurl/o) {
			if ($use_autoimg and $escapedchunk =~ /\.$::image_extention$/o) {
				return &make_link_url("image",$chunk,$chunk,$escapedchunk);
			} else {
				return &make_link_url("url",$chunk,$chunk);
			}
		}
	}

	# [[name>alias]] -> [[name:alias]]
	if($chunk=~/^(.+?)>(.+?)$/) {
		$chunk=$2;
		$escapedchunk = &htmlspecialchars($1);
	} elsif($chunk=~/^(.+?):(.+?)$/) {
		$chunk=$2;
		$escapedchunk = &htmlspecialchars($1);
	}

	# local wiki page
	return &make_link_wikipage(get_fullname($chunk, $::form{mypage}),$escapedchunk);
}

=lang ja

=head2 make_link_wikipage

=over 4

=item 

&make_link_wikipage(, ɽʸ);

=item 

HTML

=item С饤



=item 

wikiڡؤΥ󥯤롣

=back

=cut

sub make_link_wikipage {
	my($chunk,$escapedchunk)=@_;
	$cookedchunk  = &encode($chunk);
	my $cookedurl=&make_cookedurl($cookedchunk);
	if ($::database{$chunk}) {
		return qq(<a title="$chunk" href="$cookedurl">$escapedchunk</a>);
	} elsif (($chunk =~ /^([^#]*)#(.+)/) && $::database{$1}) {
		return qq(<a title="$chunk" href="$cookedurl#$2">$escapedchunk</a>);
	} elsif (&is_editable($chunk)) {
		# 2005.10.27 pochi: ư󥯵ǽĥ
		if ($::editchar eq 'this') {
			return qq(<a title="$::resource{editthispage}" class="editlink" href="$::script?cmd=edit&amp;mypage=$cookedchunk">$escapedchunk</a>);
		} elsif ($::editchar) {
			# original
			return qq($escapedchunk<a title="$::resource{editthispage}" class="editlink" href="$::script?cmd=edit&amp;mypage=$cookedchunk">$::editchar</a>);
		}
	}
	return $escapedchunk;
}

=lang ja

=head2 make_link_interwiki

=over 4

=item 

&make_link_interwiki($intername, $keyword, $anchor,$escapedchunk);

=item 

HTML

=item С饤



=item 

InterWikiΥ󥯤롣

=back

=cut

sub make_link_interwiki {
	my ($intername, $keyword, $anchor,$escapedchunk) = @_;
	if($escapedchunk eq '') {
		$escapedchunk=$anchor;
		$anchor="";
	}
	$intername=~tr/A-Z/a-z/;
	if(exists $::interwiki2{$intername}) {
		my ($code, $url) = %{$::interwiki2{$intername}};
		if($url=~/\$1/) {
			$url =~ s/\$1/&interwiki_convert($code, $keyword)/e;
		} else {
			$url.=&interwiki_convert($code, $keyword);
		}
		$url = &htmlspecialchars($url.$anchor);
		return &make_link_url("interwiki",$url,$escapedchunk);
	} else {
		my $remoteurl = $::interwiki{$intername};
		if ($remoteurl) {
			$remoteurl =~
			 s/\b(utf8|euc|sjis|ykwk|asis)\(\$1\)/&interwiki_convert($1, $localname)/e;
			return &make_link_url("interwiki",$remoteurl,$escapedcchunk);
		}
	}
}

=lang ja

=head2 make_cookedurl

=over 4

=item 

&make_cookedurl(URLפ줿);

=item 

URL

=item С饤



=item 

wikiڡؤΥϤ롣

=back

=cut

sub make_cookedurl {
	my($cookedchunk)=@_;
	return "$::script" . "?" . "$cookedchunk";
}

=lang ja

=head2 make_link_mail

=over 4

=item 

&make_link_mail(, ɽʸ);

=item 

󥫡̾(ʸ

=item С饤



=item 

᡼륢ɥ쥹Υ󥯤򤹤롣

=back

=cut

sub make_link_mail {
	my($chunk,$escapedchunk)=@_;

	my $adr=$chunk;
	$adr=~s/^[Mm][Aa][Ii][Ll][Tt][Oo]://g;
	return qq(<a href="mailto:$adr" class="mail">$escapedchunk</a>);
}

=lang ja

=head2 make_link_url

=over 4

=item 

&make_link_url(饹, , ɽʸ, );

=item 

HTML

=item С饤



=item 

URL󥯤롣

=back

=cut

sub make_link_url {
	my($class,$chunk,$escapedchunk,$img,$target)=@_;
	my $chunk2=&make_link_urlhref($chunk);
	$target="_blank" if($target eq '');
	if($img ne '') {
		$class.=($class eq '' ? 'img' : '');
		return &make_link_target($chunk2,$class,$target,"")
			. &make_link_image($img,$escapedchunk) . qq(</a>);
	}
	if($escapedchunk=~/^<img/) {
		return &make_link_target($chunk2,$class,$target,$chunk2)
			. qq($escapedchunk</a>);
	}
	return &make_link_target($chunk2,$class,$target,$escapedchunk)
			. qq($escapedchunk</a>);
}


=lang ja

=head2 make_link_target

=over 4

=item 

&make_link_target(, 饹, å, ȥʸ [, ݥåץåפ뤫ɤΥե饰]);

=item 

HTML

=item С饤



=item 

åȤURL󥯤롣

=back

=cut

sub make_link_target {
	my($url,$class,$target,$escapedchunk,$flag)=@_;
	$flag=$::use_popup if($flag eq '');
	$class=&htmlspecialchars($class);
	$target=&htmlspecialchars($target);
	my $popup_allow=$::setting_cookie{popup} ne '' ? $::setting_cookie{popup}
					: $flag+0 ? 1 : 0;
	my $target=$popup_allow != 0 ? $target : '';
	$target='' if($flag eq 2 && $url=~/ttp\:\/\/$ENV{HTTP_HOST}/);
	if($target ne '' && $flag eq 3) {
		my $tmp=$::basehref;
		$tmp=~s/\/.*//g;
		$target='' if($url=~/\Q$tmp/);
	}
	if($target eq '') {
		return qq(<a href="$url"@{[$class eq '' ? '' : qq(class="$class")]} title="$escapedchunk">);
	} elsif($::is_xhtml) {
		return qq(<a href="$url" @{[$class eq '' ? '' : qq(class="$class")]} title="$escapedchunk" onclick="return openURI('$url','$target');" onkeypress="return openURI('$url','$target');">);
	} else {
		return qq(<a href="$url" @{[$class eq '' ? '' : qq(class="$class")]} target="$target" title="$escapedchunk">);
	}
}

=lang ja

=head2 make_link_urlhref

=over 4

=item 

&make_link_urlhref(URL);

=item 

URLʸ

=item С饤



=item 

URLʸ롣

=back

=cut

sub make_link_urlhref {
	my($url)=@_;
	return &htmlspecialchars(
		&unescape(
			&unescape($url)
		)
	);
}

=lang ja

=head2 make_link_image

=over 4

=item 

&make_link_image(URL, );

=item 

HTML

=item С饤



=item 

HTMLϤ롣

=back

=cut

sub make_link_image {
	my($img,$alt)=@_;
	$img=&htmlspecialchars($img);
	$alt=$img if($alt eq '');
	return qq(<img src="@{[&make_link_urlhref($img)]}" alt="$alt" />);
}

=lang ja

=head2 get_fullname

=over 4

=item 

&get_fullname(ڡ̾, ȸڡ̾);

=item 

󥫡̾(ʸ

=item С饤



=item 

ڡ֤̾

=back

=cut

sub get_fullname {
	my ($name, $refer) = @_;

	return $refer if ($name eq '');
	if ($name eq '/') {
		$name = substr($name,1);
		return ($name eq '') ? $::FrontPage : $name;
	}
	return $refer if ($name eq './');
	if (substr($name,0,2) eq './') {
		return ($1) ? $refer . '/' . $1 : $refer;
	}
	if (substr($name,0,3) eq '../') {
		my @arrn = split('/', $name);
		my @arrp = split('/', $refer);

		while (@arrn > 0 and $arrn[0] eq '..') {
			shift(@arrn);
			pop(@arrp);
		}
		$name = @arrp ? join('/',(@arrp,@arrn)) :
			(@arrn ? "$::FrontPage/".join('/',@arrn) : $::FrontPage);
	}
	return $name;
}

=lang ja

=head2 message

=over 4

=item 

&message(ɽʸ);

=item 

HTML

=item С饤



=item 

åϤ롣

=back

=cut

sub message {
	my ($msg) = @_;
	return qq(<p><strong>$msg</strong></p>);
}

=lang ja

=head2 init_form

=over 4

=item 

ʤ

=item 

ʤ

=item С饤



=item 

ե롣

=back

=cut

sub init_form {
	if ($qCGI->param()) {
		foreach my $var ($qCGI->param()) {
			$::form{$var} = $qCGI->param($var);
		}
	} else {
		$ENV{QUERY_STRING} = $::FrontPage;
	}

	# Thanks Mr.koizumi. v0.1.4
	my $query = $ENV{QUERY_STRING};
	if ($query =~ /&/) {
		my @querys = split(/&/, $query);
		foreach (@querys) {
			$_ = &decode($_);
			$::form{$1} = $2 if (/([^=]*)=(.*)$/);
		}
	} else {
		$query = &decode($query);
	}

	if ($query =~ /^($wiki_name)$/) {
		$::form{cmd} = 'read';
		$::form{mypage} = $1;
	} elsif (&is_exist_page($query)) {
		$::form{cmd} = 'read';
		$::form{mypage} = $query;
	}

	# mypreview_edit        -> do_edit, with preview.
	# mypreview_adminedit   -> do_adminedit, with preview.
	# mypreview_write       -> do_write, without preview.
	foreach (keys %::form) {
		if (/^mypreview_(.*)$/) {
			$::form{cmd} = $1;
			$::form{mypreview} = 1;
		}
	}
	$::form{mymsg} = &code_convert(\$::form{mymsg},   $::defaultcode);
	$::form{myname} = &code_convert(\$::form{myname}, $::defaultcode);
	$::form{mypage} = &code_convert(\$::form{mypage}, $::defaultcode)
		if($::form{mypage}=~/[\x1-\x1f\x81-\xfe]/);
	$::form{refer} = &code_convert(\$::form{refer}, $::defaultcode);
}

=lang ja

=head2 getcookie

=over 4

=item 

&getcookie($cookieμID, %cookie);

=item 

%cookie

=item С饤



=item 

cookie롣

=back

=cut

sub getcookie {
	my($cookieID,%buf)=@_;
	my @pairs;
	my $pair;
	my $cname;
	my $value;
	my %DUMMY;

	@pairs = split(/;/,&decode($ENV{'HTTP_COOKIE'}));
	foreach $pair (@pairs) {
		($cname,$value) = split(/=/,$pair,2);
		$cname =~ s/ //g;
		$DUMMY{$cname} = $value;
	}
	@pairs = split(/,/,$DUMMY{$cookieID});
	foreach $pair (@pairs) {
		($cname,$value) = split(/:/,$pair,2);
		$buf{$cname} = $value;
	}
	return %buf;
}

=lang ja

=head2 setcookie

=over 4

=item 

&setcookie($cookieμID,ͭ,%cookie);

=item 

ʤ

=item С饤



=item 

cookieꤹ뤿HTTPإå򥻥åȤ롣

ͭ¤ˤϡʲοͤΤǤ롣

 1$::cookie_expireͭˤ롣

 0åΤ¸롣

-1cookieõ롣

=back

=cut

sub setcookie {
	my($cookieID,$expire,%buf)=@_;
	my $date;
	my $data;
	if($expire+0 > 0) {
		$date=&date("D, j-M-Y H:i:s",time+&gettz*3600+$::cookie_expire);
	} elsif($expire+0 < 0) {
		$date=&date("D, j-M-Y H:i:s",1);
	}
	$buf{cookietime}=time;
	while(($name,$value)=each(%buf)) {
		$data.="$name:$value," if($name ne '');
	}
	$data=~s/,$//g;
	$data=&encode($data);
	$::HTTP_HEADER.=qq(Set-Cookie: $cookieID=$data;);
	$::HTTP_HEADER.=qq( path=$::basepath;);
	$::HTTP_HEADER.=" expires=$date GMT" if($expire ne 0);
	$::HTTP_HEADER.="\n";
}

=lang ja

=head2 update_recent_changes

=over 4

=item 

ʤ

=item 

ʤ

=item С饤



=item 

RecentChangesڡ򹹿롣

=back

=cut


sub update_recent_changes {
	my $update = "- @{[&get_now]} @{[&armor_name($::form{mypage})]} @{[&get_subjectline($::form{mypage})]}";
	my @oldupdates = split(/\r?\n/, $::database{$::RecentChanges});
	my @updates;
	foreach (@oldupdates) {
		/^\- \d\d\d\d\-\d\d\-\d\d \(...\) \d\d:\d\d:\d\d (.*?)\ \ \-/;	# date format.
		my $name = &unarmor_name($1);
		if (&is_exist_page($name) and ($name ne $::form{mypage})) {
			push(@updates, $_);
		}
	}
	unshift(@updates, $update) if (&is_exist_page($::form{mypage}));
	splice(@updates, $::maxrecent + 1);
	$::database{$::RecentChanges} = join("\n", @updates);
}

=lang ja

=head2 get_subjectline

=over 4

=item 

&get_subjectline(ڡ̾,Կ,%ץ);

=item 

Plainʸ

=item С饤



=item 

ڡΣԤ롣ƤˤäƤϣܡܤˤʤ뤳Ȥ롣

=back

=cut

sub get_subjectline {
	my ($page, $lines,%option) = @_;
	$lines=1 if($lines+0 < 1);
	my $line;
	if (not &is_editable($page)) {
		return "";
	}
	# Delimiter check.
	my $delim = $subject_delimiter;
	$delim = $option{delimiter} if (defined($option{delimiter}));
	# Get the subject of the page.
	my $subject = $::database{$page};
	my $i=1;
	foreach (split(/\n/,$subject)) {
		s/\(\((.*)\)\)//gex;			# thanks to Ayase
		my $tmp=&text_to_html($_);
		$tmp=~s/[\xd\xa]//g;
		$tmp=~s/<.*?>//g;
		$tmp=&trim($tmp);
		next if($tmp eq '');
		$line.=$i eq 1 ? $tmp : "\n$tmp";
		last if($line ne '' && $i++ >= $lines);
	}
	if($lines > 1) {
		return $line;
	}
	$line =~ s/\r?\n.*//s;
	return "$delim$line";
}

=lang ja

=head2 send_mail_to_admin

=over 4

=item 

&send_mail_to_admin(ڡ̾,$mode);

=item 

ʤ

=item С饤



=item 

ԸwikiιƤ᡼뤹롣

=back

=cut

sub send_mail_to_admin {
	my ($page, $mode) = @_;
	return unless $modifier_sendmail;
	my $message = <<"EOD";
To: $::modifier_mail
From: $::modifier_mail
Subject: [Wiki]$mode $::basehref
MIME-Version: 1.0
Content-Type: text/plain; charset=ISO-2022-JP
Content-Transfer-Encoding: 7bit

--------
WIKI = $::modifier_rss_title
MODE = $mode
REMOTE_ADDR = $ENV{REMOTE_ADDR}
REMOTE_HOST = $ENV{REMOTE_HOST}
--------
$page
--------
$::database{$page}
--------
EOD
	$message=&code_convert(\$message, 'jis');
	open(MAIL, "| $modifier_sendmail");
	print MAIL $message;
	close(MAIL);
}

=lang ja

=head2 open_db

=over 4

=item 

ʤ

=item 

ʤ

=item С饤



=item 

˥ǡ١򳫤

=back

=cut

sub open_db {
	&dbopen($::data_dir,\%::database);
	&dbopen($::info_dir,\%::infobase);
}

=lang ja

=head2 dbopen

=over 4

=item 

&dbopen(dir, \%db);

=item 

ʤ

=item С饤



=item 

ǡ١򳫤

=back

=cut

sub dbopen {
	my($dir,$db)=@_;
	if ($modifier_dbtype eq 'dbmopen') {
		dbmopen(%$db, $dir, 0666) or &print_error("(dbmopen) $dir");
	} elsif($modifier_dbtype eq 'AnyDBM_File') {
		tie(%$db, "AnyDBM_File", $dir, O_RDWR|O_CREAT, 0666) or &print_error("(tie AnyDBM_File) $dir");
	} else {	# Yuki::YukiWikiDB & Nana::YukiWikiDB
		tie(%$db, "$modifier_dbtype", $dir) or &print_error("(tie $modifier_dbtype) $dir");
	}
	return %db;
}

=lang ja

=head2 close_db

=over 4

=item 

ʤ

=item 

ʤ

=item С饤



=item 

٤ƤΥǡ١Ĥ

=back

=cut

sub close_db {
	&dbclose(\%::database);
	&dbclose(\%infobase);
}

=lang ja

=head2 dbclose

=over 4

=item 

&dbclose(\%db);

=item 

ʤ

=item С饤



=item 

ǡ١򳫤

=back

=cut

sub dbclose {
	my($db)=@_;
	if ($modifier_dbtype eq 'dbmopen') {
		dbmclose(%$db);
	} else {
		untie(%$db);
	}
}

=lang ja

=head2 opendiff

=over 4

=item 

ʤ

=item 

ʤ

=item С饤



=item 

diffǡ١򳫤

=back

=cut

sub open_diff {
	&dbopen($::diff_dir,\%::diffbase);
}

=lang ja

=head2 close_diff

=over 4

=item 

ʤ

=item 

ʤ

=item С饤



=item 

diffǡ١Ĥ롣

=back

=cut

sub close_diff {
	&dbclose(\%::diffbase);
}

=lang ja

=head2 is_readable

=over 4

=item 

&is_readable(ڡ̾);

=item 

ڡġԲĥե饰

=item С饤



=item 

ڡαġԲĥե饰֤

=back

=cut

sub is_readable {
	my($page)=@_;
	return 0 if($page eq $::RecentChanges);	# do not delete
#	return 0 if($page=~/testauth/);	# debug
	return 1;
}

=lang ja

=head2 is_editable

=over 4

=item 

&is_editable(ڡ̾);

=item 

ԽġԲĥե饰

=item С饤



=item 

ڡοԽġԲĥե饰֤

=back

=cut

sub is_editable {
	my ($page) = @_;
	return 0 if($fixedpage{$page} || $fixedplugin{$::form{cmd}});
	return 0 if(
		$page=~/([\xa\xd\f\t\[\]])|(\.{1,3}\/)|^\s|\s$|^\#|^\/|\/$|^$|^$interwiki_name1$|^$::ismail$/o);
#	return 0 if (&is_bracket_name($page) || $fixedpage{$page});	# debug
#	return 0 if ($fixedplugin{$::form{cmd}});					# debug
#	return 0 if ($page=~/(\x0a|\x0d|\f|\t)/ || $page=~/^\s/ || $page =~/\s$/);# debug
#	return 0 if ($page=~/^$interwiki_name1$/ || $page=~/^\#/);	# debug
#	return 0 if ($page =~ /(^|\/)\.{1,2}(\/|$)/); # ./ ../ is ng# debug
#	return 0 if ($page=~/^\// || $page=~/\/$/);					# debug
#	return 0 if ($page eq '' || not $page);						# debug
	return 0 if (not &is_readable($page));
	return 1;
}

=lang ja

=head2 armor_name

=over 4

=item 

&armor_name(ʸ);

=item 

Ѵ줿ʸ

=item С饤



=item 

ʲʸѴԤʤ

WikiNameWikiName

WikiNameǤϤʤΡWikiNameǤϤʤϡ

=back

=cut

sub armor_name {
	my ($name) = @_;
	return ($name =~ /^$wiki_name$/o) ? $name : "[[$name]]";
}

=lang ja

=head2 unarmor_name

=over 4

=item 

&armor_name(ʸ);

=item 

Ѵ줿ʸ

=item С饤



=item 

ʲʸѴԤʤ

WikiNameWikiName

ΡWikiNameǤϤʤϡϢWikiNameǤϤʤ

=back

=cut

sub unarmor_name {
	my ($name) = @_;
	return ($name =~ /^$bracket_name$/o) ? $1 : $name;
}

=lang ja

=head2 is_bracket_name

=over 4

=item 

&is_bracket_name(ʸ);

=item 

֥饱åȤǤ뤫Υե饰

=item С饤



=item 

֥饱åȤǤ뤫Υե饰֤

=back

=cut

sub is_bracket_name {
	my ($name) = @_;
	return ($name =~ /^$bracket_name$/o) ? 1 : 0;
}

=lang ja

=head2 dbmname

=over 4

=item 

&dbmname(ʸ);

=item 

Ѵ줿ʸ

=item С饤



=item 

ʸDBѤHEXѴ롣

=back

=cut

sub dbmname {
	my ($name) = @_;
#	$name =~ s/(.)/uc unpack('H2', $1)/eg;
	$name =~ s/(.)/$::_dbmname_encode{$1}/g;
	return $name;
}

=lang ja

=head2 undbmname

=over 4

=item 

&undbmname(ʸ);

=item 

Ѵ줿ʸ

=item С饤



=item 

DBѤHEXѴ줿ʸ᤹

=back

=cut

sub undbmname {
	my ($name) = @_;
#	$name =~ s/(.)/uc unpack('H2', $1)/eg;
	$name =~ s/([0-9A-F][0-9A-F])/$::_dbmname_decode{$1}/g;
	return $name;
}

=lang ja

=head2 decode

=over 4

=item 

&decode(ʸ);

=item 

Ѵ줿ʸ

=item С饤



=item 

URL󥳡ɤ줿ʸǥɤ롣

=back

=cut

sub decode {
	my ($s) = @_;
	$s =~ tr/+/ /;
#	$s =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C", hex($1))/eg;	# better ? # debug
	$s =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/chr(hex($1))/eg;
	return $s;
}

=lang ja

=head2 encode

=over 4

=item 

&encode(ʸ);

=item 

Ѵ줿ʸ

=item С饤



=item 

URL󥳡ɤ򤹤롣

=back

=cut

sub encode {
	my ($encoded) = @_;
#	$encoded =~ s/(\W)/'%' . unpack('H2', $1)/eg;
	$encoded =~ s/(\W)/$::_urlescape{$1}/g;
	return $encoded;
}

=lang ja

=head2 read_resource

=over 4

=item 

&read_resource(ե̾, %꥽);

=item 

%꥽

=item С饤



=item 

꥽եɤ߹

=back

=cut

sub read_resource {
	my ($file,%buf) = @_;
	return %buf if $::_resource_loaded{$file}++;
	open(FILE, $file) or &print_error("(resource:$file)");
	while (<FILE>) {
		s/[\r\n]//g;
		next if /^#/;
		s/\\n/\n/g;
		my ($key, $value) = split(/=/, $_, 2);
#		꥽EUCǤ뤳ȤѤ
#		$buf{$key} = &code_convert(\$value, $::defaultcode);
		$buf{$key}=$value;
	}
	close(FILE);
	return %buf;
}

=lang ja

=head2 conflict

=over 4

=item 

&conflict(ڡ̾, ʸ);

=item 

0:ͤʤ 1:

=item С饤



=item 

ڡξͤ򸡺롣

=back

=cut

sub conflict {
	my ($page, $rawmsg) = @_;
	if ($::form{myConflictChecker} eq &get_info($page, $::info_ConflictChecker)) {
		return 0;
	}
	open(FILE, "$::res_dir/conflict.$::lang.txt") or &print_error("(conflict)");
	#v0.1.6 add comment
	my $content;
	foreach(<FILE>) {
		$content.=$_ if(! /^#/);
	}
#	꥽EUCǤ뤳ȤѤ
#	$content=&code_convert(\$content, $::defaultcode);
	close(FILE);

	my $body = &text_to_html($content);
	if (&exist_plugin('edit') == 1) {
		$body .= &plugin_edit_editform($rawmsg, $::form{myConflictChecker}, frozen=>0, conflict=>1);
	}

	&skinex($page, $body, 0);
	return 1;
}

=lang ja

=head2 get_now

=over 4

=item 

ʤ

=item 

ʸ

=item С饤



=item 

롣

=back

=cut

sub get_now {
	my (@week) = qw(Sun Mon Tue Wed Thu Fri Sat);
	my ($sec, $min, $hour, $day, $mon, $year, $weekday) = localtime(time);
	$weekday = $week[$weekday];
	return sprintf("%d-%02d-%02d ($weekday) %02d:%02d:%02d",
		$year + 1900, $mon + 1, $day, $hour, $min, $sec);
}

=lang ja

=head2 init_InterWikiName

=over 4

=item 

ʤ

=item 

%::interwiki, %::interwiki2

=item С饤



=item 

InterWikiν򤹤롣

񼰤ϰʲΤȤ

[[YukiWiki http://www.hyuki.com/yukiwiki/wiki.cgi?euc($1)]]

[http://www.hyuki.com/yukiwiki/wiki.cgi?$1 YukiWiki] euc

=back

=cut

sub init_InterWikiName {
	my $content = $::database{$InterWikiName};
	while ($content =~ /$interwiki_definition/g) {
		my ($name, $url) = ($1, $2);
		#v0.1.6
		$name=~tr/A-Z/a-z/;
		$::interwiki{$name} = $url;
	}
	while ($content =~ /$interwiki_definition2/g) {
		#v0.1.6
		my ($url,$name,$code)=($1,$2,$3);
		$name=~tr/A-Z/a-z/;
		$::interwiki2{$name}{$code} = $url;
	}
}

=lang ja

=head2 interwiki_convert

=over 4

=item 

&interwiki_convert($type, $localname);


=item 

Ѵʸ

=item С饤



=item 

InterWikiURLؤѴ򤹤롣

=back

=cut

sub interwiki_convert {
	my ($type, $localname) = @_;
	if ($type eq 'sjis' or $type eq 'euc' or $type eq 'utf8') {
		$localname=&code_convert(\$localname, $type)
			if($localname=~/[\xa1-\xfe]/);
		return &encode($localname);
	} elsif (($type eq 'ykwk') || ($type eq 'yw')) {
		# for YukiWiki1
		if ($localname =~ /^$wiki_name$/) {
			return $localname;
		} else {
			$localname=&code_convert(\$localname, 'sjis')
				if($localname=~/[\xa1-\xfe]/);
			return &encode("[[" . $localname . "]]");
		}
#	} elsif (($type eq 'asis') || ($type eq 'raw')) {
#		return $localname;
	} else {
		return $localname;
	}
}

=lang ja

=head2 get_info

=over 4

=item 

&get_info(ڡ̾, );


=item 

ʸ

=item С饤



=item 

InfoBase롣

=back

=cut

sub get_info {
	my ($page, $key) = @_;
	my %info = map { split(/=/, $_, 2) } split(/\n/, $infobase{$page});
	return $info{$key};
}

=lang ja

=head2 set_info

=over 4

=item 

&set_info(ڡ̾, , );


=item 

ʤ

=item С饤



=item 

InfoBase˾ꤹ롣

=back

=cut

sub set_info {
	my ($page, $key, $value) = @_;
	my %info = map { split(/=/, $_, 2) } split(/\n/, $infobase{$page});
	$info{$key} = $value;
	my $s = '';
	for (keys %info) {
		$s .= "$_=$info{$_}\n";
	}
	$infobase{$page} = $s;
}

=lang ja

=head2 frozen_reject

=over 4

=item 

($::form{mypage});

=item 

0:뤵ƤʤޤǧںѤ 1:뤵Ƥ롣

=item С饤



=item 

ǧڤԤʤ

=back

=cut

sub frozen_reject {
	my ($isfrozen) = &get_info($::form{mypage}, $info_IsFrozen);
	my ($willbefrozen) = $::form{myfrozen};
	my %auth;
	if (not $isfrozen and not $willbefrozen) {
		# You need no check.
		return 0;
	} else {
		%auth=&authadminpassword(form,"","frozen");
		return ($auth{authed} eq 0 ? 1 : 0);
	}
	return 0;
}

=lang ja

=head2 is_frozen

=over 4

=item 

&is_frozen(ڡ̾);

=item 

0:뤵Ƥʤ 1:뤵Ƥ롣

=item С饤



=item 

ꤷڡ뤵Ƥ뤫å롣

=back

=cut

sub is_frozen {
	my ($page) = @_;
	if($::newpage_auth eq 1) {
		return 1 if(!&is_exist_page($page));
	}
	return (&get_info($page, $info_IsFrozen)) ? 1 : 0;
}

=lang ja

=head2 exist_plugin

=over 4

=item 

&exist_plugin(ץ饰̾);

=item 

0:ʤ 1:PyukiWiki 2:YukiWiki

=item С饤



=item 

ץ饰ɤ߹

=back

=cut

sub exist_plugin {
	my ($plugin) = @_;

	if (!$_plugined{$plugin}) {
		my $path = "$::plugin_dir/$plugin" . '.inc.pl';
		if (-e $path) {
			require $path;
			$::debug.=$@;
			$_plugined{$1} = 1;	# Pyuki
			#v0.1.6
			$path="$::res_dir/$plugin.$::lang.txt";
			%::resource = &read_resource($path,%::resource) if(-r $path);
			return 1;
		} else {
			$path = "$::plugin_dir/$plugin" . '.pl';
			if (-e $path) {
				require $path;
				$::debug.=$@;
				$_plugined{$1} = 2;	# Yuki
				return 2;
			}
		}
		return 0;
	}
	return $_plugined{$plugin};
}

=lang ja

=head2 exist_explugin

=over 4

=item 

&exist_explugin(ץ饰̾);

=item 

0:ʤ 1:ɤ߹ߺѤ

=item С饤



=item 

ĥץ饰ɤ߹

=back

=cut

sub exist_explugin {
	my ($explugin) = @_;

	if (!$_exec_plugined{$explugin}) {
		my $path = "$::explugin_dir/$explugin" . '.inc.cgi';
		if (-e $path) {
			require $path;
			$::debug.=$@;
			$_exec_plugined{$1} = 1;	# Loaded
			$path="$::res_dir/$explugin.$::lang.txt";
			%::resource = &read_resource($path,%::resource) if(-r $path);
			return 1;
		}
		return 0;
	}
	return $_exex_plugined{$explugin};
}

=lang ja

=head2 embedded_to_html

=over 4

=item 

&embedded_to_html(ʸ);

=item 

ʸ

=item С饤



=item 

֥åץ饰¹Ԥ롣

=back

=cut

sub embedded_to_html {
	my $embedded = shift;

	if ($embedded =~ /$embed_plugin/) {
		my $exist = &exist_plugin($1);
		my $action = '';
		if ($exist == 1) {
			$action = "\&plugin_" . $1 . "_convert('$3')";
		} elsif ($exist == 2) {
			$action = "\&$1::plugin_block('$3');";
		}
		if ($action ne '') {
			$_ = eval $action;
			$::debug.=$@;
			return ($_) ? $_ : &htmlspecialchars($embedded);
		}
	}
	return $embedded;
}

=lang ja

=head2 embedded_inline

=over 4

=item 

&embedded_inline(ʸ);

=item 

ʸ

=item С饤



=item 

饤󷿥ץ饰¹Ԥ롣

=back

=cut

sub embedded_inline {
	my ($embedded,$opt)=@_;
	my($cmd,$arg);
	if($embedded=~/$::embedded_inline/g) {
		if($1 ne '') {
			$cmd=$1;
			$arg=$2;
		} elsif($3 ne '') {
			$cmd=$3;
		} elsif($4 ne '') {
			$cmd=$4;
			$arg=$5;
		} elsif($6 ne '') {
			$cmd=$6;
			$arg="$7,$8";
		}
		my $exist = &exist_plugin($cmd);
		my $action = '';
		if ($exist == 1) {
			$action = "\&plugin_" . $cmd . "_inline('$arg')";
		} elsif ($exist == 2) {
			$action = "\&" . $cmd . "::plugin_inline('$arg');";
		}
		if ($action ne '') {
			$_ = eval $action;
			$::debug.=$@;
			return $_ if ($_);
		}
	}
	return $embedded if($opt eq 2);
	return &unescape($embedded);
}

=lang ja

=head2 load_module

=over 4

=item 

&load_module(⥸塼̾);

=item 

⥸塼̾

=item С饤



=item 

Perl⥸塼ɤ߹

=back

=cut

sub load_module{
	my $mod = shift;
	return $mod if $::_module_loaded{$mod}++;
	eval qq( require $mod; );
	unless($@) {						# debug
		$::debug.="$mod Loaded\n"		# debug
	} else {							# debug
		$::debug.="$mod Load failed\n"	# debug
	}									# debug
	return $mod;
}

=lang ja

=head2 code_convert

=over 4

=item 

&code_convert(ʸ, [euc|sjis|utf8|jis] [,ϥ]);

=item 

ʸ

=item С饤



=item 

饯ɤѴ롣

=back

=cut

sub code_convert {
	my ($contentref, $kanjicode, $icode) = @_;
	if($$contentref ne '') {
		if ($::lang eq 'ja') {
			if ($::code_method{ja} eq 'Unicode::Japanese') {
				my $icode_j=$icode eq '' ? 'auto' : $icode;
				&load_module("Unicode::Japanese");
				if($kanjicode eq 'sjis') {
					return Unicode::Japanese->new($$contentref,$icode_j)->sjis;
				} elsif($kanjicode eq 'euc') {
					return Unicode::Japanese->new($$contentref,$icode_j)->euc;
				} elsif($kanjicode eq 'jis') {
					return Unicode::Japanese->new($$contentref,$icode_j)->jis;
				} else {
					return Unicode::Japanese->new($$contentref,$icode_j)->get;
				}
			} elsif($::code_method{ja} eq 'jcode.pl') {
				require "jcode.pl";
				if($kanjicode=~/utf/ || $icode=~/utf/) {
					return $$contentref;
#					die "Unsupport UTF8 on jcode.pl";
				}
				my $icode_j=$icode eq '' ? $::defaultcode : $icode;
				&jcode::convert($contentref, $kanjicode, $icode_j);
			} else {
				&load_module("Jcode");
				my $icode_j=$icode eq '' ? $::defaultcode : $icode;
				&Jcode::convert($contentref, $kanjicode, $icode_j);
			}
		}
	}
	return $$contentref;
}

=lang ja

=head2 is_exist_page

=over 4

=item 

&is_exist_page(ڡ̾);

=item 

ڡ¸ߤ翿

=item С饤



=item 

ڡ¸ߤ뤫å

=back

=cut

sub is_exist_page {
	my ($name) = @_;
	return ($use_exists) ? exists($::database{$name}) : $::database{$name};
}

=lang ja

=head2 trim

=over 4

=item 

&trim(ʸ);

=item 

Ѵ줿ʸ

=item С饤



=item 

ʸ(Ⱦ)

=back

=cut

sub trim {
	my ($s) = @_;
	$s =~ s/^\s*(\S+)\s*$/$1/o; # trim
	return $s;
}

=lang ja

=head2 escape

=over 4

=item 

&escape(ʸ);

=item 

줿ʸ

=item С饤



=item 

HTML򥨥פ롣

=back

=cut

sub escape {
	return &htmlspecialchars(shift);
}

=lang ja

=head2 unescape

=over 4

=item 

&unescape(ʸ);

=item 

줿ʸ

=item С饤



=item 

פ줿HTML᤹

=back

=cut

sub unescape {
	my $s=shift;
	$s=~s/\&(amp|lt|gt|quot);/$::_unescape{$1}/g;
#	$s=~s|\&amp;|\&|g;
#	$s=~s|\&lt;|\<|g;
#	$s=~s|\&gt;|\>|g;
#	$s=~s|\&quot;|\"|g;
	return $s;
}

=lang ja

=head2 htmlspecialchars

=over 4

=item 

&htmlspecialchars(ʸ);

=item 

Ѵ줿ʸ

=item С饤



=item 

HTMLʸ򥨥פ롣

=back

=cut

sub htmlspecialchars {
	my($s)=@_;
	$s=~s/([<>"&])/$::_htmlspecial{$1}/g;
#	$s=~s|>|&gt;|g if($s=~/</);
#	$s=~s|\r\n|\n|g;
#	$s=~s|\&|&amp;|g;
#	$s=~s|<|&lt;|g;
#	$s=~s|"|&quot;|g;
	return $s;
}

=lang ja

=head2 javascriptspecialchars

=over 4

=item 

&javaspecialchars(ʸ);

=item 

Ѵ줿ʸ

=item С饤



=item 

JavaScriptʸ˼¹ԤǤ褦˥פ롣

=back

=cut

sub javascriptspecialchars {
	my($s)=@_;
	$s=&htmlspecialchars($s);
	$s=~s|'|&apos;|g;
	return $s;
}

=lang ja

=head2 valid_password

=over 4

=item 

&valid_password(Ϥ줿ѥ,admin|frozen|attach);

=item 

ѥɤפƤ1פƤʤ0

=item С饤



=item 

ԥѥǧڤ򤹤롣

=back

=cut
	# 2005.10.27 pochi: źѥѥɤ
	# Ѵѥб
	# $::adminpass / $::adminpass{attach} ....
sub valid_password {
	my ($givenpassword,$type) = @_;
	if($::adminpass{$type} eq '') {
		return (crypt($givenpassword, "AA") eq $::adminpass) ? 1 : 0;
	}
	return (crypt($givenpassword, "AA") eq $::adminpass 
		||  crypt($givenpassword, "AA") eq $::adminpass{$type}) ? 1 : 0;
}

=lang ja

=head2 passwordform

=over 4

=item 

&passwordform(ǥեȥѥ, [hidden]);

=item 

HTML

=item С饤



=item 

ѥɥեϤ롣

=back

=cut

sub passwordform {
	my($default,$mode)=@_;
	if($default eq '') {
		return qq(<input type="password" name="mypassword" size="10">);
	} elsif($mode eq 'hidden') {
		return qq(<input type="hidden" name="mypassword" value="$default">);
	} else {
		return qq(<input type="password" name="mypassword" value="$default" size="10">);
	}
}

=lang ja

=head2 authadminpassword

=over 4

=item 

&authadminpassword(form|input, ȥ, attach|frozen|admin);

=item 

%ret{authed}, %ret{html}

=item С饤



=item 

ԥѥǧڤ򤷡ɬפǤХѥɥեHTMLϤ򤹤롣

=back

=cut

sub authadminpassword {
	my($mode,$title,$type)=@_;
	my $body;

	$type=($type eq "attach" ? "attach" : $type eq "frozen" ? "frozen" : "admin");
	if($mode=~/submit|page|form/) {
		$title=$::resource{admin_passwd_prompt_title} if($title eq '');
		if(!&valid_password($::form{mypassword},$type)) {
			$body=<<EOM;
<h2>$title</h2>
@{[$ENV{REQUEST_METHOD} eq 'GET' && $::form{mypassword} eq '' ? '' : qq(<div class="error">$::resource{admin_passwd_prompt_error}</div>\n)]}
<form action="$::script" method="post" id="adminpasswordform" name="adminpasswordform">
$::resource{admin_passwd_prompt_msg}<input type="password" name="mypassword" size="10">
<input type="submit" value="$::resource{admin_passwd_button}">
EOM
			foreach my $forms(keys %::form) {
				$body.=qq(<input type="hidden" name="$forms" value="$::form{$forms}">\n);
			}
			$body.="</form>\n";
			return('authed'=>0,'html'=>$body);
		} else {
			$body.=qq(<input type="hidden" name="mypassword" value="$::form{mypassword}">\n);
			return('authed'=>1,'html'=>$body);
		}
	} else {
		if(!&valid_password($::form{mypassword},$type)) {
			$body.=<<EOM;
@{[$ENV{REQUEST_METHOD} eq 'GET' && $::form{mypassword} eq '' ? '' : qq(<div class="error">$::resource{admin_passwd_prompt_error}</div>)]}
EOM
			$body.=qq(@{[$title ne '' ? $title : $::resource{admin_passwd_prompt_msg}]}<input type="password" name="mypassword" value="$::form{mypassword}" size="10">\n);
			return('authed'=>0,'html'=>$body);
		} else {
			$body.=qq(<input type="hidden" name="mypassword" value="$::form{mypassword}">\n);
			return('authed'=>1,'html'=>$body);
		}
	}
}

=lang ja

=head2 gettz

=over 4

=item 

ʤ

=item 

GMTȤκλ

=item С饤



=item 

GMTȤκ(hour)֤

=back

=cut

my $_tz='';
sub gettz {
	if($_tz eq '') {
		$_tz=(localtime(time))[2]+(localtime(time))[3]*24+(localtime(time))[4]*24
			+(localtime(time))[5]*24-(gmtime(time))[2]-(gmtime(time))[3]*24
			-(gmtime(time))[4]*24-(gmtime(time))[5]*24;
	}
	return $_tz;
}

=lang ja

=head2 getwday

=over 4

=item 

&getwday($year,$mon,$mday);

=item 

ֹ

=item С饤



=item 



=back

=cut

sub getwday {
	my($year, $mon, $mday) = @_;

	if ($mon == 1 or $mon == 2) {
		$year--;
		$mon += 12;
	}
	return int($year + int($year / 4) - int($year / 100) + int($year / 400)
		+ int((13 * $mon + 8) / 5) + $mday) % 7;
}

=lang ja

=head2 lastday

=over 4

=item 

&lastday($year,$mon);

=item 

ǯκǽ

=item С饤



=item 

ǯκǽ롣

=back

=cut

sub lastday {
	my($year,$mon)=@_;
	return  (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)[$mon - 1]
		+ ($mon == 2 and $year % 4 == 0 and
		($year % 400 == 0 or $year % 100 != 0));
}

=lang ja

=head2 dateinit

=over 4

=item 

ʤ

=item 

ʤ

=item С饤



=item 

ʸʸ롣

=back

=cut

sub dateinit {
	my $i=0;
	foreach(split(/,/,$::resource{"date_ampm_en"})) {
		$::_date_ampm[$i++]=$_;
	}
	$i=0;
	foreach(split(/,/,$::resource{"date_ampm_".$::lang})) {
		$::_date_ampm_locale[$i++]=$_;
	}
	$i=0;
	foreach(split(/,/,$::resource{"date_weekday_en"})) {
		$::_date_weekday[$i++]=$_;
	}
	$i=0;
	foreach(split(/,/,$::resource{"date_weekday_".$::lang})) {
		$::_date_weekday_locale[$i++]=$_;
	}
	$::_date_weekdaylength=$::resource{"date_weekdaylength_en"};
	$::_date_weekdaylength_locale=$::resource{"date_weekdaylength_".$::lang};
}

=lang ja

=head2 date

=over 4

=item 

&date(format [,unixtime] [,"gmtime"]);

=item 

Ѵ줿ʸ

=item С饤



=item 

դꤷPHP񼰤Ѵ롣

=back

=cut

sub date {
	my ($format, $tm, $gmtime) = @_;
	my %weekday;
	my %ampm;

	# yday:0-365 $isdst Summertime:1/not:0
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = 
		$gmtime ne '' && @_ > 2
			? ($tm+0 > 0 ? gmtime($tm) : gmtime(time))
			: ($tm+0 > 0 ? localtime($tm) : localtime(time));

	$year += 1900;
	my $hr12=$hour=>12 ? $hour-12:$hour;

	# am / pm strings
	$ampm{en}=$::_date_ampm[$hour>11 ? 1 : 0];
	$ampm{$::lang}=$::_date_ampm_locale[$hour>11 ? 1 : 0];

	# weekday strings
	$weekday{en}=$::_date_weekday[$wday];
	$weekday{en}{length}=$::_date_weekdaylength;
	$weekday{$::lang}=$::_date_weekday_locale[$wday];
	$weekday{$::lang}{length}=$::_date_weekdaylength_locale;

	# RFC 822 (only this)
	if($format=~/r/) {
		return &date("D, j M Y H:i:s O",$tm,$gmtime);
	}
	# gmtime & 󥿡ͥåȻ
	if($format=~/[OZB]/) {
		my $gmt=&gettz;
		$format =~ s/O/sprintf("%+03d:00", $gmt)/ge;	# GMT Time
		$format =~ s/Z/sprintf("%d", $gmt*3600)/ge;		# GMT Time secs...
		my $swatch=(($tm-$gmt+90000)/86400*1000)%1000;	# GMT +1:00ˤơ1000beatˤ
														# ܻ֤ξ硢AM08:00=000
		$format =~ s/B/sprintf("%03d", int($swatch))/ge;# internet time
	}

	# UNIX time
	$format=~s/U/sprintf("%u",$tm)/ge;	# unix time

	$format=~s/lL/\x2\x13/g;	# lL:escape -
	$format=~s/DL/\x2\x14/g;	# DL:escape -
	$format=~s/D/\x2\x12/g;		# D:escape Sun-Sat
	$format=~s/aL/\x1\x13/g;	# aL:escape  or 
	$format=~s/AL/\x1\x14/g;	# AL:escape ʸ
	$format=~s/l/\x2\x11/g;		# l:escape Sunday-Saturday
	$format=~s/a/\x1\x11/g;		# a:escape am pm
	$format=~s/A/\x1\x12/g;		# A:escape AM PM
	$format=~s/M/\x3\x11/g;		# M:escape Jan-Dec
	$format=~s/F/\x3\x12/g;		# F:escape January-December

	# 뤦ǯη
	if($format=~/[Lt]/) {
		my $uru=($year % 4 == 0 and ($year % 400 == 0 or $year % 100 != 0)) ? 1 : 0;
		$format=~s/L/$uru/ge;
		$format=~s/t/(31, $uru ? 29 : 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)[$mon]/ge;
	}

	# year
	$format =~ s/Y/$year/ge;	# Y:4char ex)1999 or 2003
	$year = $year % 100;
	$year = "0" . $year if ($year < 10);
	$format =~ s/y/$year/ge;	# y:2char ex)99 or 03

	# month
	my $month = ('January','February','March','April','May','June','July','August','September','October','November','December')[$mon];
	$mon++;									# mon is 0 to 11 add 1
	$format =~ s/n/$mon/ge;					# n:1-12
	$mon = "0" . $mon if ($mon < 10);
	$format =~ s/m/$mon/ge;					# m:01-12

	# day
	$format =~ s/j/$mday/ge;				# j:1-31
	$mday = "0" . $mday if ($mday < 10);
	$format =~ s/d/$mday/ge;				# d:01-31

	# hour
	$format =~ s/g/$hr12/ge;				# g:1-12
	$format =~ s/G/$hour/ge;				# G:0-23
	$hr12 = "0" . $hr12 if ($hr12 < 10);
	$hour = "0" . $hour if ($hour < 10);
	$format =~ s/h/$hr12/ge;				# h:01-12
	$format =~ s/H/$hour/ge;				# H:00-23

	# minutes
	$format =~ s/k/$min/ge;					# k:0-59
	$min = "0" . $min if ($min < 10);
	$format =~ s/i/$min/ge;					# i:00-59

	# second
	$format =~ s/S/$sec/ge;					# S:0-59
	$sec = "0" . $sec if ($sec < 10);
	$format =~ s/s/$sec/ge;					# s:00-59

	$format =~ s/w/$wday/ge;				# w:0(Sunday)-6(Saturday)


	$format =~ s/I/$isdst/ge;	# I(Upper i):1 Summertime/0:Not

	$format =~ s/\x1\x11/$ampm{en}/ge;			# a:am or pm
	$format =~ s/\x1\x12/uc $ampm{en}/ge;		# A:AM or PM
	$format =~ s/\x1\x13/$ampm{$::lang}/ge;		# A: or 
	$format =~ s/\x1\x14/uc $ampm{$::lang}/ge;	# ʸ

	$format =~ s/\x2\x11/$weekday{en}/ge;		# l(lower L):Sunday-Saturday
	$format =~ s/\x2\x12/substr($weekday{en},0,$weekday{en}{length})/ge;	# D:Mon-Sun
	$format =~ s/\x2\x13/substr($weekday{$::lang},0,$weekday{$::lang}{length})/ge;	# D:Mon-Sun
	$format =~ s/\x2\x14/$weekday{$::lang}/ge;

	$format =~ s/\x3\x11/substr($month,0,3)/ge;	# M:Jan-Dec
	$format =~ s/\x3\x12/$month/ge;				# F:January-December

	$format =~ s/z/$yday/ge;	# z:days/year 0-366
	return $format;

	# moved date format document to plugin/date.inc.pl or date.inc.pl.ja.pod
}

1;
__END__
