######################################################################
# topicpath.inc.pl - This is PyukiWiki, yet another Wiki clone.
# $Id: topicpath.inc.pl,v 1.9 2006/02/27 09:53:13 papu Exp $
#
# "PyukiWiki" version 0.1.6-rc6 $$
# Author: Junichi http://www.re-birth.com/
# Copyright (C) 2004-2006 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-2006 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL2 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################
# ꥸʥȤѹ
# $ARROW, $FRONTPAGE ؤѹ
# PukiWiki饤ɽɲ
# 0.1.6ѤURLѹ
######################################################################

sub plugin_topicpath_inline {
######################################################################
# select or edit style
######################################################################
	# Re-Birth Original
	my $AutoLoad=1;
	my $SEPARATOR = '/';
	my $FRONTMARK = '  ';
	my $ARROW = ' &gt; ';
	my $FRONTPAGE = $::FrontPage;
	my $FRONTPAGENAME=$FRONTPAGE;
	my $PREFIX = '[ ';
	my $SUFFIX = ' ]';
######################################################################
	# PukiWiki Like
	my $AutoLoad=1;
	my $SEPARATOR = '/';
	my $FRONTMARK = ' /  ';
	my $ARROW = ' / ';
	my $FRONTPAGE = $::FrontPage;
	my $FRONTPAGENAME='Top';
	my $PREFIX = '';
	my $SUFFIX = '';
######################################################################

	# wiki.cgiɤ߹ߤȽǤ
	return '' if(shift eq 1 && $AutoLoad eq 0);

	my $mypage = $::form{mypage};

	if(!(&is_exist_page($mypage))) {
		return "";
	}

	my @path_array = split($SEPARATOR,$mypage);

	# FrontPageΥå
	$frontpageUrl = &createUrl($FRONTPAGE, $FRONTPAGE, $FRONTPAGE, $FRONTPAGENAME);

	if($mypage eq $FRONTPAGE) {
		return $PREFIX . $frontpageUrl . $SUFFIX;
	}

	$result = $frontpageUrl . $FRONTMARK;
	my $pathname = "";
	foreach $pagename (@path_array) {

		if($pathname ne "") {
			$pathname .= $SEPARATOR . $pagename;
		}else{
			$pathname = $pagename;
		}

		$result .= &createUrl($pagename, $pathname, $FRONTPAGE, $FRONTPAGENAME);

		# ǸʳĤ
		if($pagename ne $path_array[$#path_array]){
			$result .= $ARROW;
		}

	}
	return $PREFIX . $result . $SUFFIX;
}

# ex.
# $pagename : Page
# $pathname : Category/Page
sub createUrl() {
	my ($pagename,$pathname, $FRONTPAGE, $FRONTPAGENAME) = @_;

	if(&is_exist_page($pathname)) {
		return qq|<a href="@{[&make_cookedurl(&encode($pathname))]}">@{[&escape($pagename eq $FRONTPAGE ? $FRONTPAGENAME : $pagename)]}</a>|;
	} else {
		return qq|@{[&escape($pagename)]}<a href="$::script?cmd=edit&mypage=@{[&encode($pathname)]}">?</a>|;
	}
}

1;
__END__

