######################################################################
# deletecache.inc.pl - This is PyukiWiki, yet another Wiki clone.
# $Id: deletecache.inc.pl,v 1.2 2006/03/04 13:12:53 papu Exp $
#
# "PyukiWiki" version 0.1.6-rc7 $$
# Author: Nanami http://lineage.netgamers.jp/
# Copyright (C) 2004-2006 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-2006 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL2 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################

sub plugin_deletecache_action {
	my $body;

	my %auth=&authadminpassword(submit,"","admin");
	return('msg'=>"\t$::resource{deletecache_plugin_title}",'body'=>$auth{html})
		if($auth{authed} eq 0);

	&deletecache;
	$body=<<EOM;
$err_list
$delete_list
EOM
	return('msg'=>"\t$::resource{deletecache_plugin_title}",'body'=>$body);
}

sub deletecache {
	$ignore_delete_regex=q(^$|^..?$|^index|htaccess$|\..{1,3}$);
	opendir(DIR,"$::cache_dir");
	@DIR=sort readdir(DIR);
	closedir(DIR);
	foreach my $dir(@DIR) {
		if($dir!~/$ignore_delete_regex/) {
			push(@delete_list,$dir);
			if(unlink("$::cache_dir/$dir")) {
				$delete_list.=qq($::resource{deletecache_plugin_deleted} : $dir<br />\n);
			} else {
				$err_list.=qq(<div class="error">$::resource{deletecache_plugin_error} : $dir</div><br />\n);
			}
		}
	}
	return($delete_list,$err_list);
}

1;
__END__

